---
name: 使用说明
route: /
---

## 通用组件库
> 项目中使用的通用组件
基于 antd ，进行再次封装的数据绑定通用组件

### 安装
 ```
$ npm install fan-standard-comp --save
 ```
 或
 ```
$ yarn add fan-standard-comp
 ```


### 更新日志

🔥组件  🆕新增  🐞修复 🔔删除 💄优化  📝 🛠  🗑
## 2.0.x
`2020-04-16`
- 🔥 StandardFilter
  - 🌟 新增 `initialValues` 设置表单控件组初始值，只有初始化以及重置时生效
  - 🌟 新增 `getFormFields` 获取表单字段值及表单实例
  - 🛠 formItemGroup API 
      - 🔔 弃用 `filedOptions`
      - 🌟 新增 `rules` 校验规则，设置字段的校验逻辑 (由原来的filedOptions.rules转到此处)
  - 💄 优化 `icon` 支持传 String 或 ReactNode （String显示图标功能待优化，未引入图标库）
- 🔥 RenderItemGroup
  - 🔔 弃用 `disabledAll` 改正使用  `fieldStatus='disabled'`
  - 🌟 新增 `fieldStatus` 表示当前控件正常操作、禁用、或仅显示文本
  - 🛠 ItemGroup API 
    - 💄 优化 `display` 可支持传对象，即当前标签与输入控件间的布局，如{labelCol:{span: 3}, wrapperCol: {span: 8}}
- 🔥 FieldComponent
  - 🔔 调整 `type` 表单控件类型接收值 🔔 弃用 `monthPicker`,` weekPicker`, `yearPicker`
  - 🔔 弃用 `disabledAll` 改正使用  `fieldStatus='disabled'`
  - 🌟 新增 `fieldStatus` 表示当前控件正常操作、禁用、或仅显示文本
- 🔥 RefactorTree
  - 🔔 调整 `onSelect` 参数字段：`onSelect(keys, selectData(如：{ currentData, multiData: multiCheckedData }), e)`
  - 🌟 新增 `onCheck` 参数字段：`onSelect(keys,selectData(如：{ currentData, multiData: multiCheckedData }), e)`
- StandardTable
  - 💄 优化 `columns 操作列`配置 `buttonGroup` 支持方法格式，返回数组进行渲染
- SpecIcon
  - 🔔 调整 `type`默认设置值为`colour`，使用svg格式，若使用字形图标则需配置 `type="font"`
  - 🔔 调整 `prefix`默认设置为`speci`，适用为基础图标使用，若是项目内，则会使用额外定义的prefix值
- StandardModal
  - 💄 优化 `getFormFields` 弹窗类型`type='form'` 时获取弹窗内表单字段值及表单实例
  - 🌟 新增 `initialValues` 设置弹窗内表单控件组初始值
  - 🛠 formItemGroup API 
     - 🔔 弃用 `filedOptions`
     - 🌟 新增 `rules` 校验规则，设置字段的校验逻辑 (由原来的filedOptions.rules转到此处)
  - 💄 优化 `icon` 支持传 String 或 ReactNode （String显示图标功能待优化，未引入图标库）
- formItemGroup （涉及：StandardModal、StandardFilter）表单渲染配置项更新
  - 💄 优化 `isHide`,支持使用方法返回，`isHide(fieldValues,form)`, fieldValues参数可获取当前表单内所有表单项的值
  - 🌟 新增 `type='tree-select`,下拉树选择添加表单处可显示完整层级名称字段 `showFullLevel`，并添加`separator` 配置其层级分割符，默认是`/`

## 2.0.4,2.0.5
`2020-04-28`
- FieldComponent
   - 修复 控件类型为`type=select`配置`labelInValue`下只读无法显示值
   - 修复 控件类型为`type=tree-select`,渲染数据异步请求时，值显示为空白
   - 新增 控件类型为`type=select`,新增配置项`selectOptionRender`,可自定义下拉选项展示内容
   
`2020-04-29`
- RefactorTree
  - 💄 修改  `optionName` 替换成原来字段名指定的  ` key 替换成 value`  `{ value: 'id', title: 'title', children: 'children' }`
- StandardTable
  - 💄 优化 `data.pagination=false`时，隐藏页码栏

## 2.0.6
- StandardModal
  - 🐞 修复 `fieldStatus`为'viewOnly'或'disabled'时，隐藏底部按钮
- FieldComponent
  - 🐞 修复 表单控件“select"显示筛选条件配置filterOption返回值警告
  - 🐞 修复 “只读”状态，如果值为 0 时，显示异常
- StandardTable
  - 🐞 修复 表格列配置`columns`默认render返回为0时，显示成 ‘-’


## 2.0.7
  - 🌟 新增 WrapperContent,SubfieldContent 通用页面结构组件
- FieldComponent
  - 🌟 新增 控件类型`cascader， switch， slider`用法
  
## 2.0.8
- StandardModal
  - 🐞 修复  `type=form`表单实例往父组件无法派发
- FieldComponent
  - 🌟 新增 控件类型 `timePicker，timePickerRange`用法
- FormItemGroup
  - 💄 修改  `getFormFields(fields, form)`  `form`实例参数返回值为对象，无需要添加.current
- StandardFilter
  - 🔔 修改 `isHIde` 返回参数
  
  
## 2.1.0
- StandardModal
  - 🔔 修改 类组件替换成函数组件应用
  - 💄 优化 `formPrefix`和`formPostfix`方法参数，` Function(modalForm, modalProps, forceUpdateForm)`,添加第三个参数`forceUpdateForm()`用于自定义表单值更新时，强制触发表单实例更新
  - 💄 优化 `custormRender`方法参数，` Function(form,item,fieldStatus, forceUpdateForm) `,添加第四个参数`forceUpdateForm()`用于自定义表单值更新时，强制触发表单实例更新
  - 💄 优化 `isHide`使用时，需要同` ProtoFormItem.shouldUpdate `一并使用
       
- FormItemGroup
  - 💄 优化 `isHide`使用时，需要同` ProtoFormItem.shouldUpdate `一并使用

## 2.1.1
- FieldComponent
  - 💄 优化 控件类型 `tree-select`的选择 `onSelect`参数优化，第二个node参数返回加上当前节点的原始数据，及添加第四个参数`nodeParent`返回当前节点上级父节点集合
  - 💄 优化 控件类型 `password`只读时，只显示 ●●●●●●
  - 💄 优化 所有控件设置禁用时，`disabled=true或fieldsStatus='disabled'`时，控件值为空时不显示`placeholder`
  - 🐞 修复 `type="select"`控件配置 `labelInValue`时，只读状态显示值异常
  - 💄 优化 `tree-select`配置`disabled`字段值
- RenderItemGroup
  - 💄 优化 内部表单控件`onChange`配置参数还原成原始官方API参数
- Uploader
  - 💄 修复 在弹窗关闭后无法重新渲染图片

## 2.1.2
- StandardTable
  - 💄 优化 操作列 权限配置返回按钮数量
  - 🌟 新增 配置参数  `codes`,`permissionCodes`,用于配置按钮组权限
- StandardFilter
  - 💄 优化 筛选条件 重置及赋值数据未清空
  - 💄 优化 操作列 权限配置返回按钮数量
  - 🌟 新增 配置参数  `codes`,`permissionCodes`,用于配置按钮组权限
- ButtonGroup
  - 🌟 新增 按钮组配置，主要用于表格与筛选按钮组合数据过滤
- FieldComponent
  - 💄 优化 控件类型 `switch`只读状态不显示文本，显示控件并对其禁用
  
## 2.1.3
- FieldFilter
  - 🐞 修复 筛选 buttonGroup 未配置参数时异常值判断
- StandardModal
  - 🐞 修复 弹窗未配置renderButtonGroup 时hideFooter未生效
- StandardTable
  - 🐞 修复 操作列isHide配置返回异常，及对应参数异常
  - 🐞 优化 操作列放开`confirmText`配置限制（原来只针对 codeBtnDelete）
  
## 2.1.4
- FieldComponent
  - 🐞 修复 `tree-select` 详情只读模式未显示当前名称
  - 🐞 修复 `tree-select` 只读模式可显示多选择时的当前数据
  - 💄 优化 `select` 设置  `option`的 `title`配置，用于鼠标经过点击完整名称
  - 💄 优化 `select、input、textarea、tree-select` 禁用模式下鼠标经过显示完整值
  - 🐞 修复 `tree-select` 返回值为[]，禁用状态显示异常警告

- StandardTable
  - 🌟 表格操作列 `type:action` 新增配置  `min` 的 用于最小展示按钮数，其余超出将被折叠显示
- StandardFilter
  - 🌟 筛选按钮组 新增配置  `min` 的 用于最小展示按钮数，其余超出将被折叠显示
  - 🔔 修复 筛选组件重置未清空表单
- RenderItemGroup
  - 💄 优化 表单组 `itemGroup` 单个控件可配置 fieldStatus
  
## 2.1.5
- StandardForm
  - 🆕 添加 表单控件
- fieldComponent
  - 💄 优化 password 无值时不显示文本，tree-select 旧文件显示样式调整
- RenderItemGroup
  - 🆕 新增 `layout` 表单控件布局模式（继承表单配置）
- StandardModal
  - 🆕 新增 `layout`参数，展示表单布局

## 2.1.6
- fieldComponent
  - 💄 tree-select配置disabled时且多选择下(treeCheckable=true)，不显示 title
- RenderItemGroup
  - 🐞 修复 表单组控件必填标识显示判断
- StandardFilter,StandardTable
  - 💄 优化 按钮组元素带子集合时，由于权限判断结果为[]，不显示其父节点
- RenderItemGroup
  - 🐞 修复 表单组 type='custom'配置隐藏无效
- fieldComponent
  - 🐞 修复 表单控件radio,tree-select提示“ref"异常
  - 💄 优化  `tree-select` 详情只读模式配置`showFullLevel`和`showCheckedStrategy`显示完整路径
  - 💄 优化 `radio`和`checkbox` 新增配置`selectOptionRender`，可自定义选项展示内容
  - 💄 优化 `checkbox` 配置`separator`，可自定义分隔符

## 2.1.7
- RefactorTree
  - 🐞 修复 配置根节点情况下，数据list为空时不隐藏节点
- SpecIcon
  - 🐞 修复 图标组件应用时样式引用字段库无法识别

## 2.1.8
- SpecIcon
  - 🐞 修复 “字体”图标伪类样式异常
  
## 2.1.9
` 2020-08-05`
- FieldComponent
   - 💄 优化 控件`select`相关的更改事件`onChange(value, Option)`参数返回值 `Option`累加当前选中数据的完整字段
   
## 2.1.10
` 2020-09-27`
- DragBar
   - 🆕 添加 上下左右拉动条
- DragContent
   - 🆕 添加 可拉伸的容器
- SubfieldContent
   - 💄 优化 左侧内容配置`leftSiderDragDirection`设置左侧容器可拉伸
   
## 2.1.11
` 2020-10-13`
- Uploader
   - 🐞 修复 预览弹窗隐藏按钮组
   
` 2020-10-14`
- StepForm
 - 💄 优化 调整步骤表单内展示结构，交对其步骤按钮组的切换添加校验规则，具体查看DEMO，涉及 `stepClick\actions`等相关配置调整
 - 💄 优化 步骤切换可配置内部校验或自定义校验
- StandardModal
 - 💄 优化 `tyep=stepForm`按钮组配置事件处理(配置校验处理)

## 2.1.12
` 2020-10-20`
- FieldComponent
 - 💄 优化 `type=inputNumber`控件增加最大输入长度限制 
` 2020-10-23`
- Uploader
   - 💄 优化 新增支持svg格式上传预览
   - 💄 修复 控件台报ref不存在警告

## 2.1.13
` 2020-11-06`
- FieldComponent
 - 💄 优化 `type=uploader` 只读情况下，value值不为数组情况下判断
 - 💄 优化 `type` 不赋值情况下，显示文本值

` 2020-11-06`
- SpecIcon
 - 🆕 添加 `noPrefix`属性，用于配置图标没有 分割符'-' name渲染
 
` 2020-11-17`
- StandardModal
 - 💄 优化 调整小号弹窗表单栅格
- Uploader
 - 💄 优化 调整 校验异常时，边框样式
 - 💄 优化 当有配置扩展值`extraExt`时，svg文件限制提示将去掉
- FieldComponent
 - 💄 优化  `tree-select`下拉树控件`showFullLevel`状态下提示文本

` 2020-11-24`
- ButtonGroup
 - 💄 优化  图标`icon`无prefix时配置方式
- StandardModal
 - 💄 优化 弹窗底部按钮渲染 `footerButtonGroup` 数组内数据支持返回DOM

` 2020-11-27`
- uploader
 - 🆕  添加  `className`配置
- SubfieldContent
 - 💄 优化 左侧栏超出滚动条显示调整
- FieldComponent
 - 💄 优化  `select`重置返回完整字段值
 
## 2.1.14
` 2020-12-2`
- FieldComponent
 - 💄 优化  `tree-select`配置`labelInValue`时，显示完整名称
 
` 2020-12-3`
- StandardModal
 - 💄 添加 弹窗底部按钮参数配置 `cancelButtonProps,okButtonProps`
 
` 2020-12-4`
- RenderItemGroup
 - 💄 优化 `displayLayout`配置优先级低于单个控件配置`display`的值

## 2.1.15
` 2020-12-3`
- FieldComponent
 - 💄 还原 `select` 重置返回完整字段值   
 
` 2020-12-16`
- uploader
 - 💄 优化 去除文件类型校验判断  
 

` 2020-12-17`
- RefactorTree
  - 💄 修复 旧Icon图标应用

` 2020-12-18`
- RefactorTree
  - 💄 优化 树数据渲染模式，移除TreeNode渲染

## 2.1.16
` 2020-12-18`
- RenderItemGroup
  - 💄 优化 `type=title`或`type='html'`可配置隐藏`isHide`,用法同其他类型控件

- ButtonGroup
  - 💄 新增 `confirmConfig` 用于气泡确认框扩展配置

## 2.1.17
` 2021-01-18`
- StandardFilter
  - 修复 @height-base在antd3.0中无对应变量


## 2.2.0
` 2021-02-02`
- SpliterLayout
  - 添加 分割布局组件
