function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import axios from 'axios';
/**
 * 查询文件上传情况
 * @param {String} fileHash 文件内容Hash
 * @param {String} fileName 文件名
 * @param {Number} chunksLength 分片数量
 */

export function queryFileInfo(_ref) {
  var fileHash = _ref.fileHash,
      fileName = _ref.fileName,
      size = _ref.size,
      sizeStr = _ref.sizeStr,
      chunksLength = _ref.chunksLength;
  console.log('queryFileInfo ==> 查询文件上传情况');
  return axios.get('/getFileInfo', {
    params: {
      fileHash: fileHash,
      fileName: fileName,
      size: size,
      sizeStr: sizeStr,
      chunksLength: chunksLength
    }
  }).then(function (_ref2) {
    var data = _ref2.data;
    return data;
  });
}
/**
 * 上传文件分片
 * @param {String} fileContentHash 文件的Hash
 * @param {Number} chunkIndex 分片序号
 * @param {Blob} chunk 文件分片
 */

export function uploadChunk(fileContentHash, chunkIndex, chunk) {
  var formData = new FormData();
  formData.append('fileContentHash', fileContentHash);
  formData.append('chunkIndex', chunkIndex);
  formData.append('chunk', chunk);
  return axios.post('/uploadChunk', formData).then(function (_ref3) {
    var result = _ref3.data;
    return result;
  });
}
export function lockChunk(fileHash, chunkIndex) {
  return axios.post('/lockChunk', {
    fileHash: fileHash,
    chunkIndex: chunkIndex
  }).then( /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref4) {
      var result;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              result = _ref4.data;
              return _context.abrupt("return", result);

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref5.apply(this, arguments);
    };
  }());
}