function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/* eslint-disable no-unused-vars */
import React, { useEffect, useState, useRef } from 'react';
import PropTypes from 'prop-types';
import { getComponentDisplayName, splitFileToChunks, calFileContentHash, bytesToSize, guid } from './lib';
import { queryFileInfo } from './api';
import UploadQueue from './upload-queue.class';
import './style.css';
/**
 * 初始化组件
 * @param {ReactComponent} component 本高阶组件
 * @param {ReactComponent} WrappedComponent 被包装的具体实现组件
 */

function useComponentInit(component, WrappedComponent) {
  var intervalIDArr = [];

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      filesList = _useState2[0],
      setFilesList = _useState2[1]; // 定义管理上传的列表

  /* 定义上传队列，初始化就创建一个UploadQueue类实例 */


  var _useState3 = useState(new UploadQueue({
    /* 设立一个定时器，定时（根据hash）查询文件是否上传完成（因为后端需要把所有分片合并起来，因此需要一定的时间） */
    fileFinishCb: function fileFinishCb(fileHash) {
      /* 查询文件是否上传完成；是的话则更新状态，渲染上传结果 */
      console.log('调用=》fileFinishCb==》查询文件是否上传完成；是的话则更新状态，渲染上传结果');

      function checkIfFinish() {
        return _checkIfFinish.apply(this, arguments);
      }
      /*
        第一次定时器会很快触发，这是针对小文件，争取尽快渲染上传结果
        之后的定时器则是针对较大的文件，以较大的时间间隔来触发查询
      */


      function _checkIfFinish() {
        _checkIfFinish = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
          var remoteFileInfo;
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.next = 2;
                  return queryFileInfo({
                    fileHash: fileHash
                  });

                case 2:
                  remoteFileInfo = _context3.sent;
                  console.log('请求接口queryFileInfo=》 完成分片上传后，更新上传状态');

                  if (!(remoteFileInfo.status === 'finish')) {
                    _context3.next = 7;
                    break;
                  }

                  updateFileInfo.call({
                    filesList: filesList,
                    setFilesList: setFilesList
                  }, fileHash, {
                    status: remoteFileInfo.status,
                    url: remoteFileInfo.publicPath
                  });
                  return _context3.abrupt("return", true);

                case 7:
                  console.log('更新上传状态==》remoteFileInfo', remoteFileInfo);
                  return _context3.abrupt("return", false);

                case 9:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3);
        }));
        return _checkIfFinish.apply(this, arguments);
      }

      setTimeout( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var intervalID;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return checkIfFinish();

              case 2:
                _context2.t0 = _context2.sent;

                if (!(_context2.t0 === false)) {
                  _context2.next = 6;
                  break;
                }

                intervalID = setInterval( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return checkIfFinish();

                        case 2:
                          _context.t0 = _context.sent;

                          if (!(_context.t0 === true)) {
                            _context.next = 6;
                            break;
                          }

                          clearInterval(intervalID);
                          intervalIDArr.splice(intervalIDArr.indexOf(intervalIDArr), 1);

                        case 6:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                })), 5000);
                intervalIDArr.push(intervalID);

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      })), 500);
    }
  })),
      _useState4 = _slicedToArray(_useState3, 1),
      uploadQueue = _useState4[0];

  useEffect(function () {
    /* 定义displayName是为了在浏览器开发者工具里更好地显示高阶组件名称 */
    component.displayName = "withUploader(".concat(getComponentDisplayName(WrappedComponent), ")");
    component.defaultProps = {
      perChunkSize: 1024 * 512,
      errorCb: function errorCb() {},
      finishCb: function finishCb() {}
    };
    component.propTypes = {
      perChunkSize: PropTypes.number,
      errorCb: PropTypes.func,
      finishCb: PropTypes.func
    };
  }, [component, WrappedComponent]);
  /* 清理所有定时器 */

  useEffect(function () {
    return function () {
      intervalIDArr.forEach(function (intervalID) {
        return clearInterval(intervalID);
      });
    };
  }, [intervalIDArr]);
  return {
    filesList: filesList,
    setFilesList: setFilesList,
    uploadQueue: uploadQueue
  };
}
/**
 * 根据用户选择上传的文件来初始化文件信息，并添加到state里
 * @param {File} file 用户选择上传的文件
 */


function initFilesListState(file) {
  var fileInfo = {
    hash: guid(),
    // 用uuid来假装hash
    fileName: file.name,
    status: 'init',
    publicPath: '',
    size: file.size,
    sizeStr: bytesToSize(file.size) // 转换当前字节数

  };
  this.setFilesList([].concat(_toConsumableArray(this.filesList), [fileInfo]));
  console.log('根据用户选择上传的文件来初始化文件信息', fileInfo);
  return fileInfo;
}
/**
 * 根据文件hash查询当前组件管理的文件列表里是否已存在目标文件
 * @param {String} hash 文件hash
 */


function checkDuplicateByHash(hash) {
  return this.filesList.some(function (file) {
    return file.hash === hash;
  });
}
/**
 * 根据文件hash，从当前组件管理的文件列表中删除目标文件信息
 * @param {Object} currentFileInfo 用户当前选择上传的文件的信息
 */


function removeFile(currentFileInfo) {
  this.setFilesList(function (filesList) {
    return filesList.filter(function (file) {
      return currentFileInfo.hash !== file.hash;
    });
  });
}
/**
 * 更新state中的文件信息
 * @param {String} hash 文件hash
 * @param {Object} newFileAttrs 需要更新的文件信息字段；不需要更新的字段就不需要传进来
 */


function updateFileInfo(hash, newFileAttrs) {
  console.log('updateFileInfo=》 更新state中的文件信息');
  this.setFilesList(function (filesList) {
    return filesList.map(function (file) {
      return file.hash === hash ? _objectSpread(_objectSpread({}, file), newFileAttrs) : file;
    });
  });
  console.log('最新的this.filesList=》', this.filesList);
}
/**
 * <input type="file">的change事件回调函数
 * @param {Number} perChunkSize 每个分片的大小
 * @param {Function} errorCb 错误异常的处理函数
 */


function returnFileInputChangeCb(_ref3) {
  var _this = this;

  var perChunkSize = _ref3.perChunkSize,
      errorCb = _ref3.errorCb;
  console.log('调用input更新事件');
  return /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(event) {
      var file, currentFileInfo, chunksArr, fileContentHash, remoteFileInfo;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              file = event.target.files[0];
              currentFileInfo = initFilesListState.call(_this, file);
              console.log('当前已选择需要上传的文件', file);
              chunksArr = splitFileToChunks(file, perChunkSize); // 文件分片

              _context4.next = 6;
              return calFileContentHash(chunksArr);

            case 6:
              fileContentHash = _context4.sent;

              // 计算文件内容的hash
              if (checkDuplicateByHash.call(_this, fileContentHash)) {
                removeFile.call(_this, currentFileInfo);
                errorCb({
                  errorCode: 1,
                  message: 'duplicate file found by hash'
                });
              }

              console.log('当前文件内的fileContentHash', fileContentHash);
              updateFileInfo.call(_this, currentFileInfo.hash, {
                hash: fileContentHash
              });
              /* 查询该文件上传情况 */

              _context4.next = 12;
              return queryFileInfo(_objectSpread(_objectSpread({}, currentFileInfo), {}, {
                fileHash: fileContentHash,
                chunksLength: chunksArr.length
              }));

            case 12:
              remoteFileInfo = _context4.sent;
              console.log('请求接口queryFileInfo=》初始化，返回当前文件上传情况 =>remoteFileInfo：', remoteFileInfo);
              updateFileInfo.call(_this, fileContentHash, {
                status: remoteFileInfo.status,
                url: remoteFileInfo.publicPath,
                chunks: remoteFileInfo.chunks,
                chunksLength: remoteFileInfo.chunksLength
              });
              /* 秒传 */

              if (!(remoteFileInfo.status === 'finish')) {
                _context4.next = 17;
                break;
              }

              return _context4.abrupt("return");

            case 17:
              _this.uploadQueue.addChunksToQueue(remoteFileInfo, chunksArr); // 建立上传队列


              _this.uploadQueue.run(); // 触发上传


            case 19:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x) {
      return _ref4.apply(this, arguments);
    };
  }();
}
/**
 * 高阶组件的主函数
 * @param {ReactComponent} WrappedComponent 被封装的具体实现的组件
 */


export default function withUploader(WrappedComponent) {
  return function UploaderHoc(props) {
    var perChunkSize = props.perChunkSize,
        errorCb = props.errorCb,
        restProps = _objectWithoutProperties(props, ["perChunkSize", "errorCb"]);

    var fileInputRef = useRef(null);
    var state = useComponentInit(UploaderHoc, WrappedComponent);
    /* 组装传给具体实现组件的props */

    var spreadProps = _objectSpread(_objectSpread({}, restProps), {}, {
      // 透传
      triggerFile: function triggerFile() {
        return fileInputRef.current.click();
      },
      filesList: state.filesList
    });

    return /*#__PURE__*/React.createElement("div", {
      className: "upload-hoc"
    }, /*#__PURE__*/React.createElement("input", {
      ref: fileInputRef,
      type: "file",
      className: "upload-hoc_file-input",
      onChange: returnFileInputChangeCb.call(state, {
        perChunkSize: perChunkSize,
        errorCb: errorCb
      })
    }), /*#__PURE__*/React.createElement(WrappedComponent, spreadProps));
  };
}