function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// eslint-disable-next-line import/no-webpack-loader-syntax
import Worker from 'worker-loader!./worker.js'; // 启动 Web Worker

/**
 * 获取组件名称
 * @param {ReactComponent} component
 */

export function getComponentDisplayName(component) {
  return component.displayName || component.name || 'Component';
}
/**
 * 文件切分分片
 * @param {File} file 文件
 */

export function splitFileToChunks(file, perChunkSize) {
  var fileSize = file.size;
  var total = Math.ceil(fileSize / perChunkSize); // 计算总共要分多少片

  var chunksArr = [];

  for (var i = 1; i <= total; i++) {
    chunksArr.push(file.slice((i - 1) * perChunkSize, i * perChunkSize));
  }

  console.log('splitFileToChunks==》文件切分分片', chunksArr);
  return chunksArr;
}
/**
 * 利用WebWorker计算文件内容的Hash
 * @param {File} file 文件
 */

export function calFileContentHash(_x) {
  return _calFileContentHash.apply(this, arguments);
}
/**
 * 把字节数转化成更友好的显示（单位转化）
 * @param {String} bytes 字节数
 * @param {Number} precise 小数精度
 */

function _calFileContentHash() {
  _calFileContentHash = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(chunksArr) {
    var worker;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            worker = new Worker();
            worker.postMessage({
              chunksArr: chunksArr
            }); // 传递文件分片

            /* 接受计算好的hash */

            return _context.abrupt("return", new Promise(function (resolve) {
              worker.onmessage = function (event) {
                resolve(event.data.hash);
              };
            }));

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _calFileContentHash.apply(this, arguments);
}

export function bytesToSize(bytes) {
  var precise = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
  if (bytes === 0) return '0 B';
  var k = 1024,
      sizes = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'],
      i = Math.floor(Math.log(bytes) / Math.log(k));
  return (bytes / Math.pow(k, i)).toFixed(precise) + ' ' + sizes[i];
}
/**
 * 生成guid
 */

export function guid() {
  function S4() {
    return ((1 + Math.random()) * 0x10000 | 0).toString(16).substring(1);
  }

  return "".concat(S4()).concat(S4(), "-").concat(S4(), "-").concat(S4(), "-").concat(S4(), "-").concat(S4()).concat(S4()).concat(S4());
}