import "antd/es/tree-select/style";
import _TreeSelect from "antd/es/tree-select";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useRef, useState, useEffect } from "react";
import './index.less';
import { getParentNodes, getNodePaths } from '../../utils';
import { UpOutlined, DownOutlined } from "@ant-design/icons";
var TreeNode = _TreeSelect.TreeNode;
var RefactorTreeSelect = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$treeData = props.treeData,
      treeData = _props$treeData === void 0 ? [] : _props$treeData,
      value = props.value,
      showFullLevel = props.showFullLevel,
      _props$separator = props.separator,
      separator = _props$separator === void 0 ? '/' : _props$separator,
      disabled = props.disabled,
      fieldStatus = props.fieldStatus,
      _props$treeOptionName = props.treeOptionName,
      treeOptionName = _props$treeOptionName === void 0 ? {
    title: 'title',
    value: 'value',
    children: 'children',
    disabled: 'disabled'
  } : _props$treeOptionName,
      placeholder = props.placeholder,
      protoTreeNode = props.protoTreeNode,
      _onSelect = props.onSelect,
      labelInValue = props.labelInValue,
      otherProps = _objectWithoutProperties(props, ["treeData", "value", "showFullLevel", "separator", "disabled", "fieldStatus", "treeOptionName", "placeholder", "protoTreeNode", "onSelect", "labelInValue"]);

  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      fullLevelName = _useState2[0],
      setFullLevelName = _useState2[1];

  var renderTreeNode = function renderTreeNode(data, dataOptionName) {
    var nodeProps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return data.map(function (item) {
      if (item[dataOptionName.children] && item[dataOptionName.children].length > 0) {
        return /*#__PURE__*/React.createElement(TreeNode, _extends({
          title: item[dataOptionName.title],
          key: item[dataOptionName.value],
          value: item[dataOptionName.value],
          disabled: item[dataOptionName.disabled]
        }, nodeProps), renderTreeNode(item[dataOptionName.children], dataOptionName));
      }

      return /*#__PURE__*/React.createElement(TreeNode, _extends({
        title: item[dataOptionName.title],
        key: item[dataOptionName.value],
        value: item[dataOptionName.value],
        disabled: item[dataOptionName.disabled]
      }, nodeProps));
    });
  };

  useEffect(function () {
    if (value) {
      // 获取选中节点相关数据：包括当前完整数据值、当前父节点以上层层级节点数据集合及id集合
      var nodeInfo = getParentNodes(treeData, labelInValue ? value.value : value, {
        childrenParam: treeOptionName.children,
        keyParam: treeOptionName.value
      }, _objectSpread({}, otherProps));
      setFullLevelName(renderParenName(nodeInfo));
    } else {
      // value，无值时
      setFullLevelName(null);
    }
  }, [value, treeData, fieldStatus]);

  var renderParenName = function renderParenName(selectNodeInfo) {
    // 有父级节点，及当前模式是showFullLevel时，渲染名称为完整层级名称，否则为当前节点名称
    var parentItems = selectNodeInfo.nodeParent;

    if (parentItems.length > 0 && showFullLevel && !otherProps.showCheckedStrategy) {
      // 当前查找到的父级节点拼合当前节点的标题字段值进行显示
      return parentItems.reverse().map(function (item) {
        return item[treeOptionName.title];
      }).concat(selectNodeInfo.matchNode[0][treeOptionName.title]).join(separator);
    }

    if (Array.isArray(value)) {
      return selectNodeInfo.matchNode.length > 0 ? selectNodeInfo.matchNode.map(function (item) {
        return item[treeOptionName.title];
      }).join(',') : null;
    }

    return selectNodeInfo.matchNode.length > 0 ? selectNodeInfo.matchNode[0][treeOptionName.title] : null;
  };

  var renderTreeSelectNode = function renderTreeSelectNode() {
    return /*#__PURE__*/React.createElement(_TreeSelect, _extends({
      placeholder: placeholder,
      value: value,
      ref: ref
    }, otherProps, {
      labelInValue: labelInValue,
      title: otherProps.title || ((disabled || fieldStatus === 'disabled') && !otherProps.treeCheckable ? fullLevelName : null),
      showCheckedStrategy: otherProps.showCheckedStrategy,
      disabled: disabled,
      onSelect: function onSelect(value, node, extra) {
        var newNodeInfo = getParentNodes(treeData, value, {
          childrenParam: treeOptionName.children,
          keyParam: treeOptionName.value
        });
        setFullLevelName(renderParenName(newNodeInfo));
        if (_onSelect) _onSelect(value, _objectSpread(_objectSpread({}, node), newNodeInfo.matchNode[0]), extra, newNodeInfo.nodeParent);
      }
    }), renderTreeNode(treeData, treeOptionName, protoTreeNode || {}));
  };

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      showAllPath = _useState4[0],
      setShowAllPath = _useState4[1]; // 显示所有树选择路径


  var renderTreeSelectNodePath = function renderTreeSelectNodePath() {
    //获取节点路径
    var pathNodes = getNodePaths(treeData, value, {
      childrenParam: treeOptionName.children,
      keyParam: treeOptionName.value
    }, _objectSpread({}, otherProps));

    var togglePath = function togglePath() {
      setShowAllPath(!showAllPath);
    };

    if (pathNodes.length > 0) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
        className: "tree-select-viewonly-list ".concat(showAllPath ? 'collapsed' : '')
      }, pathNodes.map(function (item, index) {
        if (item.length > 0) {
          // 超过2个且不显示所有
          if (index > 1 && !showAllPath) return;
          return /*#__PURE__*/React.createElement("div", {
            className: 'tree-select-viewonly-item',
            key: index
          }, /*#__PURE__*/React.createElement("b", null, "\xB7 "), item.map(function (i) {
            return i[treeOptionName.title];
          }).join(separator));
        }
      }), pathNodes.length > 2 ? /*#__PURE__*/React.createElement("div", {
        className: "toggle-icon",
        onClick: togglePath
      }, !showAllPath ? /*#__PURE__*/React.createElement(React.Fragment, null, "\u5C55\u5F00 ", /*#__PURE__*/React.createElement(DownOutlined, null)) : /*#__PURE__*/React.createElement(React.Fragment, null, "\u6536\u8D77 ", /*#__PURE__*/React.createElement(UpOutlined, null))) : null));
    } else {
      return '-';
    }
  };

  if (fieldStatus === 'viewOnly') {
    //多选下拉框 详情展示 showCheckedStrategy 有值且显示完整路径时
    if (otherProps.showCheckedStrategy && showFullLevel) {
      return renderTreeSelectNodePath();
    }

    return fullLevelName || '-'; // 只读显示时，只返回文本
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null, showFullLevel && !otherProps.showCheckedStrategy ? /*#__PURE__*/React.createElement("div", {
    className: "refactor-tree-select ".concat(disabled ? 'refactor-disabled' : ''),
    title: fullLevelName || ''
  }, renderTreeSelectNode(), /*#__PURE__*/React.createElement("span", {
    className: "refactor-tree-select-extra"
  }, fullLevelName)) : renderTreeSelectNode());
});
export default RefactorTreeSelect;