import "antd/es/slider/style";
import _Slider from "antd/es/slider";
import "antd/es/switch/style";
import _Switch from "antd/es/switch";
import "antd/es/cascader/style";
import _Cascader from "antd/es/cascader";
import "antd/es/upload/style";
import _Upload from "antd/es/upload";
import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/time-picker/style";
import _TimePicker from "antd/es/time-picker";
import "antd/es/radio/style";
import _Radio from "antd/es/radio";
import "antd/es/checkbox/style";
import _Checkbox from "antd/es/checkbox";
import "antd/es/input-number/style";
import _InputNumber from "antd/es/input-number";
import "antd/es/date-picker/style";
import _DatePicker from "antd/es/date-picker";
import "antd/es/select/style";
import _Select from "antd/es/select";
import "antd/es/input/style";
import _Input from "antd/es/input";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from "react";
import Uploader from '../Uploader/index';
import SpecIcon from '../../SpecIconFont/index';
import RefactorTreeSelect from './RefactorTreeSelect.js';
import { setSelectValue, setUploaderValue, setDatePickerValue, setTimePickerValue, setCascaderValue } from './setReadonlyValues.js';
var TextArea = _Input.TextArea,
    Password = _Input.Password;
var Option = _Select.Option;
var RangePicker = _DatePicker.RangePicker; // 表单组件类型

var FieldComponent = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var type = props.type,
      _onChange = props.onChange,
      value = props.value,
      style = props.style,
      placeholder = props.placeholder,
      protoConfig = props.protoConfig,
      _props$treeData = props.treeData,
      treeData = _props$treeData === void 0 ? [] : _props$treeData,
      filedName = props.filedName,
      _props$selectOptionNa = props.selectOptionName,
      selectOptionName = _props$selectOptionNa === void 0 ? {
    value: 'value',
    label: 'label',
    disabled: 'disabled',
    title: 'title'
  } : _props$selectOptionNa,
      _props$treeOptionName = props.treeOptionName,
      treeOptionName = _props$treeOptionName === void 0 ? {
    title: 'title',
    value: 'value',
    children: 'children',
    disabled: 'disabled'
  } : _props$treeOptionName,
      _props$fieldStatus = props.fieldStatus,
      fieldStatus = _props$fieldStatus === void 0 ? 'default' : _props$fieldStatus,
      showFullLevel = props.showFullLevel,
      separator = props.separator,
      selectOptionRender = props.selectOptionRender;
  var selectOptions = props.selectOptions;
  var compContent;

  if (selectOptionName && selectOptions) {
    // 将传值的数据进行转换
    selectOptions = selectOptions.map(function (item) {
      return _objectSpread(_objectSpread({}, item), {}, {
        value: item[selectOptionName.value || 'value'],
        label: item[selectOptionName.label || 'label'],
        disabled: item[selectOptionName.disabled || 'disabled'],
        title: item[selectOptionName.title || 'title']
      });
    });
  }

  var defaultProps = _objectSpread({
    style: style,
    onChange: _onChange,
    value: value,
    ref: ref
  }, protoConfig);

  if (fieldStatus === 'disabled') {
    defaultProps.disabled = true;
  }

  var sortLimitRule = {}; // 排序字段长度限制

  if (filedName === 'sorts' || filedName === 'sort' || filedName === 'indexSort' || filedName === 'sorta' || filedName === 'categorySort') {
    sortLimitRule = {
      min: 0,
      max: 999999999,
      maxLength: 9
    };
  } // 设置纯展示模式下的“下拉树”控件返回值


  var viewOnly = fieldStatus === 'viewOnly'; // 是否纯展示

  switch (type) {
    case 'input':
      compContent = viewOnly ? value || '-' : /*#__PURE__*/React.createElement(_Input, _extends({
        placeholder: fieldStatus === 'disabled' || defaultProps.disabled ? '' : defaultProps.placeholder || placeholder || '请输入',
        autoComplete: "off",
        title: fieldStatus === 'disabled' || defaultProps.disabled ? value : null,
        maxLength: defaultProps.maxLength || 50
      }, defaultProps));
      break;

    case 'password':
      compContent = viewOnly ? value ? "\u25CF\u25CF\u25CF\u25CF\u25CF\u25CF" : '-' : /*#__PURE__*/React.createElement(Password, _extends({
        autoComplete: "off",
        placeholder: fieldStatus === 'disabled' || defaultProps.disabled ? '' : defaultProps.placeholder || placeholder || '请输入',
        maxLength: defaultProps.maxLength || 50
      }, defaultProps));
      break;

    case 'textarea':
      compContent = viewOnly ? value || '-' : /*#__PURE__*/React.createElement(TextArea, _extends({
        placeholder: fieldStatus === 'disabled' || defaultProps.disabled ? '' : defaultProps.placeholder || placeholder || '请输入',
        maxLength: defaultProps.maxLength || 500,
        title: fieldStatus === 'disabled' || defaultProps.disabled ? value : null
      }, defaultProps));
      break;

    case 'inputNumber':
      compContent = viewOnly ? value || 0 : /*#__PURE__*/React.createElement(_InputNumber, _extends({
        placeholder: fieldStatus === 'disabled' || defaultProps.disabled ? '' : defaultProps.placeholder || placeholder || '请输入数字'
      }, sortLimitRule, defaultProps));
      break;

    case 'select':
      // 重置返回完整字段值
      var resetResultOption = function resetResultOption(Option) {
        if (!Option) return Option;
        if (Array.isArray(Option)) return selectOptions.filter(function (childOpt) {
          return Option.filter(function (optItem) {
            return childOpt.value === optItem.value;
          }).length > 0;
        }); // 数据为数组

        return _objectSpread(_objectSpread({}, Option), selectOptions.filter(function (childOpt) {
          return childOpt.value === Option.value;
        })[0]);
      };

      compContent = viewOnly ? setSelectValue(value, {
        selectOptions: selectOptions,
        selectOptionRender: selectOptionRender,
        defaultProps: defaultProps,
        type: type
      }) : /*#__PURE__*/React.createElement(_Select, _extends({
        allowClear: true,
        placeholder: fieldStatus === 'disabled' || defaultProps.disabled ? '' : defaultProps.placeholder || placeholder || "".concat(defaultProps.showSearch ? '请输入选择' : '请选择'),
        filterOption: function filterOption(input, option) {
          return defaultProps.showSearch ? option.children.toLowerCase().indexOf(input.toLowerCase()) >= 0 : false;
        },
        value: value
      }, defaultProps, {
        // onChange返回参数：累加当前选中包括其他字段值的数据
        onChange: function onChange(value, Option) {
          return _onChange(value, resetResultOption(Option));
        } // 数据为对象

      }), selectOptions.map(function (val) {
        return /*#__PURE__*/React.createElement(Option, {
          value: val.value,
          key: val.value,
          title: selectOptionRender ? selectOptionRender(val) : val.title || val.label,
          disabled: val.disabled
        }, selectOptionRender ? selectOptionRender(val) : val.label);
      }));
      break;

    case 'tree-select':
      compContent = /*#__PURE__*/React.createElement(RefactorTreeSelect, _extends({
        treeData: treeData,
        treeOptionName: treeOptionName,
        allowClear: true,
        separator: separator,
        showFullLevel: showFullLevel,
        placeholder: fieldStatus === 'disabled' || defaultProps.disabled ? '' : defaultProps.placeholder || placeholder || '请选择',
        protoTreeNode: protoConfig && protoConfig.TreeNode || {},
        fieldStatus: fieldStatus
      }, defaultProps));
      break;

    case 'checkbox':
      delete defaultProps.ref;
      compContent = viewOnly ? setSelectValue(value, {
        selectOptions: selectOptions,
        selectOptionRender: selectOptionRender,
        defaultProps: defaultProps,
        separator: separator
      }) : /*#__PURE__*/React.createElement(_Checkbox.Group, _extends({}, defaultProps, {
        style: _objectSpread({
          width: 'auto'
        }, defaultProps.style)
      }), selectOptions && selectOptions.map(function (val) {
        return /*#__PURE__*/React.createElement(_Checkbox, {
          value: val.value,
          key: val.value,
          title: selectOptionRender ? selectOptionRender(val) : val.title || val.label,
          disabled: val.disabled
        }, selectOptionRender ? selectOptionRender(val) : val.label);
      }));
      break;

    case 'radio':
      delete defaultProps.ref;
      compContent = viewOnly ? setSelectValue(value, {
        selectOptions: selectOptions,
        selectOptionRender: selectOptionRender,
        defaultProps: defaultProps
      }) : /*#__PURE__*/React.createElement(_Radio.Group, _extends({}, defaultProps, {
        style: _objectSpread({
          width: 'auto'
        }, defaultProps.style)
      }), selectOptions && selectOptions.map(function (val) {
        return /*#__PURE__*/React.createElement(_Radio, {
          value: val.value,
          key: val.value,
          title: selectOptionRender ? selectOptionRender(val) : val.title || val.label,
          disabled: val.disabled
        }, selectOptionRender ? selectOptionRender(val) : val.label);
      }));
      break;

    case 'datePicker': // 使用配置 picker设置其属于week,month,year

    case 'dateTimePicker':
      compContent = viewOnly ? setDatePickerValue(value, {
        type: type,
        protoConfig: protoConfig
      }) : /*#__PURE__*/React.createElement(_DatePicker, _extends({
        showTime: defaultProps.showTime || type === 'dateTimePicker',
        placeholder: fieldStatus === 'disabled' || defaultProps.disabled ? '' : defaultProps.placeholder || placeholder || '请选择'
      }, defaultProps, {
        style: _objectSpread({
          'minWidth': 'auto'
        }, defaultProps.style)
      }));
      break;

    case 'rangePicker':
    case 'rangeTimePicker':
      if (fieldStatus === 'disabled' || defaultProps.disabled) defaultProps.placeholder = ''; // 禁用时，placeHolder不显示

      compContent = viewOnly ? setDatePickerValue(value, {
        type: type,
        protoConfig: protoConfig
      }) : /*#__PURE__*/React.createElement(RangePicker, _extends({
        showTime: defaultProps.showTime || type === 'rangeTimePicker'
      }, defaultProps, {
        style: _objectSpread({
          width: type === 'rangeTimePicker' ? 'auto' : '100%'
        }, defaultProps.style)
      }));
      break;

    case 'timePicker':
      if (fieldStatus === 'disabled' || defaultProps.disabled) defaultProps.placeholder = ''; // 禁用时，placeHolder不显示

      compContent = viewOnly ? setTimePickerValue(value, {
        type: type,
        protoConfig: protoConfig
      }) : /*#__PURE__*/React.createElement(_TimePicker, _extends({}, defaultProps, {
        style: _objectSpread(_objectSpread({
          'minWidth': 'auto'
        }, defaultProps.style), {}, {
          width: 'auto'
        })
      }));
      break;

    case 'timePickerRange':
      if (fieldStatus === 'disabled' || defaultProps.disabled) defaultProps.placeholder = ''; // 禁用时，placeHolder不显示

      compContent = viewOnly ? setTimePickerValue(value, {
        type: type,
        protoConfig: protoConfig
      }) : /*#__PURE__*/React.createElement(_TimePicker.RangePicker, _extends({}, defaultProps, {
        style: _objectSpread(_objectSpread({
          'minWidth': 'auto'
        }, defaultProps.style), {}, {
          width: 'auto'
        })
      }));
      break;

    case 'upload':
      compContent = /*#__PURE__*/React.createElement(_Upload, defaultProps, defaultProps.fileList && defaultProps.fileList.length >= 1 || defaultProps.defaultFileList && defaultProps.defaultFileList.length >= 1 ? null : /*#__PURE__*/React.createElement(_Button, null, /*#__PURE__*/React.createElement(SpecIcon, {
        name: "upload"
      }), " \u70B9\u51FB\u4E0A\u4F20"));
      break;

    case 'uploader':
      compContent = viewOnly ? setUploaderValue(value) : /*#__PURE__*/React.createElement(Uploader, defaultProps); // compContent = <Uploader {...defaultProps}></Uploader>

      break;

    case 'cascader':
      compContent = viewOnly ? setCascaderValue(value, {
        selectOptions: selectOptions,
        selectOptionRender: selectOptionRender,
        defaultProps: defaultProps
      }) : /*#__PURE__*/React.createElement(_Cascader, _extends({
        options: selectOptions,
        allowClear: true,
        placeholder: fieldStatus === 'disabled' || defaultProps.disabled ? '' : defaultProps.placeholder || placeholder || '请选择'
      }, defaultProps));
      break;

    case 'switch':
      compContent = /*#__PURE__*/React.createElement(_Switch, _extends({}, defaultProps, {
        disabled: viewOnly || defaultProps.disabled,
        checked: value,
        style: _objectSpread(_objectSpread({}, defaultProps.style), {}, {
          width: 'auto'
        })
      })); // compContent = viewOnly ? (String(value) === 'undefined' ? '-' : String(value)) : (<Switch {...defaultProps} checked={value} style={{ ...defaultProps.style, width: 'auto' }} />)

      break;

    case 'slider':
      compContent = viewOnly ? value : /*#__PURE__*/React.createElement(_Slider, _extends({}, defaultProps, {
        style: _objectSpread({}, defaultProps.style)
      }));
      break;

    case 'custom':
      compContent = defaultProps.customRender && defaultProps.customRender(props) || null;
      break;

    default:
      compContent = value;
      break;
  }

  return compContent;
});
export default FieldComponent;