import "antd/es/row/style";
import _Row from "antd/es/row";
import "antd/es/tooltip/style";
import _Tooltip from "antd/es/tooltip";
import "antd/es/col/style";
import _Col from "antd/es/col";
import "antd/es/form/style";
import _Form from "antd/es/form";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

import React, { useEffect } from "react";
import { general } from '../../data/index';
import FieldComponent from '../FieldComponent/index';
import SpecIcon from '../../SpecIconFont/index';
var FormItem = _Form.Item;

var RenderItemGroup = function RenderItemGroup(props) {
  var itemGroup = props.itemGroup,
      _props$size = props.size,
      size = _props$size === void 0 ? 'md' : _props$size,
      _props$fieldStatus = props.fieldStatus,
      fieldStatus = _props$fieldStatus === void 0 ? 'default' : _props$fieldStatus,
      displayLayout = props.displayLayout,
      form = props.form,
      doUpdateFormFields = props.doUpdateFormFields,
      _props$layout = props.layout,
      layout = _props$layout === void 0 ? "horizontal" : _props$layout;

  var setColSpan = function setColSpan(display, modalSize) {
    if (_typeof(display) === 'object' || display === 'block' || modalSize === 'xs') {
      return 24;
    }

    if (modalSize === 'lg') {
      return 8;
    }

    return 12;
  };

  var updateFormFields = function updateFormFields(newVal) {
    // if (newVal) form && form.setFieldsValue({ ...newVal })
    if (doUpdateFormFields) doUpdateFormFields(); // 用于触发更新表单实例赋值
  }; // useEffect(() => {
  //   // updateFormFields()
  // }, [form])
  // 渲染隐藏指定控件


  var itemIsHide = function itemIsHide(isHide, getFieldsValue, FormInstance) {
    if (typeof isHide === 'function') {
      return isHide(getFieldsValue, FormInstance, fieldStatus);
    }

    return isHide || false;
  }; // 渲染表单控件


  var renderFormField = function renderFormField(field) {
    var componentStyle = field.componentStyle,
        extra = field.extra,
        preExtra = field.preExtra; // 当前可传参的配置值
    // 带前缀或后缀控件渲染

    if (preExtra || extra) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, preExtra ? preExtra() : '', /*#__PURE__*/React.createElement(FormItem, {
        noStyle: true,
        name: field.filedName
      }, /*#__PURE__*/React.createElement(FieldComponent, _extends({}, field, {
        onChange: function onChange(eOrValue) {
          updateFormFields();

          for (var _len = arguments.length, otherParams = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            otherParams[_key - 1] = arguments[_key];
          }

          if (field.onChange) field.onChange.apply(field, [eOrValue].concat(otherParams));
        },
        fieldStatus: field.fieldStatus || fieldStatus,
        style: componentStyle || _objectSpread({}, general.formItemStyle.wide)
      }))), extra ? extra() : '');
    } else {
      return /*#__PURE__*/React.createElement(FieldComponent, _extends({}, field, {
        onChange: function onChange(eOrValue) {
          // let updateValue = val
          // if (field.type === 'input' || field.type === 'textarea' || field.type === 'radio' || field.type === 'password') {
          //   updateValue = val.target.value
          // }
          // updateFormFields({ [field.filedName]: updateValue })
          updateFormFields(); // if (field.onChange) field.onChange(val, form)

          for (var _len2 = arguments.length, otherParams = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            otherParams[_key2 - 1] = arguments[_key2];
          }

          if (field.onChange) field.onChange.apply(field, [eOrValue].concat(otherParams));
        },
        fieldStatus: field.fieldStatus || fieldStatus,
        style: componentStyle || _objectSpread({}, general.formItemStyle.wide)
      }));
    }
  };

  if (itemGroup && Array.isArray(itemGroup)) {
    return /*#__PURE__*/React.createElement(_Row, {
      type: "flex"
    }, itemGroup.map(function (item, index) {
      var label = item.label,
          description = item.description,
          isHide = item.isHide,
          type = item.type,
          customRender = item.customRender,
          filedName = item.filedName,
          _item$display = item.display,
          display = _item$display === void 0 ? 'side' : _item$display; // 当前可传参的配置值

      var formLayout = {};

      if (typeof display === 'string') {
        formLayout = display === 'block' ? general.modalSize[size].formBlockLayout : general.modalSize[size].formLayout;
      } else {
        formLayout = item.display; // 对象类型传值如： {labelCol: {span: 3},wrapperCol: {span: 8}}
      }

      if (displayLayout) {
        // 如果未配置，则使用以下配置值
        formLayout = _objectSpread({}, displayLayout);
      }

      if (type === 'title' || type === 'html') {
        return /*#__PURE__*/React.createElement(_Col, {
          key: index,
          span: item.colSpan || 24
        }, type === 'title' ? /*#__PURE__*/React.createElement("h3", {
          className: "modalPanelTitle"
        }, label) : label);
      } // 判断是否强制重新渲染表单


      if (type !== 'custom' && item.protoFormItem && item.protoFormItem.shouldUpdate) {
        return /*#__PURE__*/React.createElement(FormItem, {
          key: index,
          noStyle: true,
          shouldUpdate: item.protoFormItem.shouldUpdate
        }, function (FormInstance) {
          // isHide 返回为true则隐藏当前控件
          return !itemIsHide(isHide, FormInstance.getFieldValue(), FormInstance) ? /*#__PURE__*/React.createElement(_Col, {
            key: index,
            span: item.colSpan || setColSpan(item.display, size)
          }, " ", /*#__PURE__*/React.createElement(FormItem, _extends({
            name: type !== 'custom' && filedName,
            className: fieldStatus === 'viewOnly' ? 'form-item-view-only' : '',
            label: description ? /*#__PURE__*/React.createElement("span", null, label, /*#__PURE__*/React.createElement(_Tooltip, {
              title: description
            }, /*#__PURE__*/React.createElement(SpecIcon, {
              name: "info"
            }))) : label,
            rules: item.rules || (item.fieldOptions ? item.fieldOptions.rules : [])
          }, formLayout, item.protoFormItem), renderFormField(_objectSpread({}, item)))) : null;
        });
      }

      return /*#__PURE__*/React.createElement(_Col, {
        key: index,
        span: item.colSpan || setColSpan(item.display, size)
      }, " ", /*#__PURE__*/React.createElement(FormItem, _extends({
        name: type !== 'custom' && filedName,
        className: fieldStatus === 'viewOnly' ? 'form-item-view-only' : '',
        label: description ? /*#__PURE__*/React.createElement("span", null, label, /*#__PURE__*/React.createElement(_Tooltip, {
          title: description
        }, /*#__PURE__*/React.createElement(SpecIcon, {
          name: "info"
        }))) : label,
        rules: item.rules || (item.fieldOptions ? item.fieldOptions.rules : [])
      }, formLayout, item.protoFormItem), type === 'custom' && customRender ? customRender(form, _objectSpread({}, item), fieldStatus) : renderFormField(_objectSpread({}, item))));
    }));
  }

  return itemGroup;
  /* 如果是ReactNode则直接返回 */
};

export default RenderItemGroup;