import "antd/es/upload/style";
import _Upload from "antd/es/upload";
import "antd/es/message/style";
import _message from "antd/es/message";
import "antd/es/button/style";
import _Button from "antd/es/button";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useEffect, useMemo, useCallback } from 'react';
import { PlusOutlined } from '@ant-design/icons';
import StandardModal from '../../StandardModal/index';
import './index.less';

function getBase64(file) {
  return new Promise(function (resolve) {
    var reader = new FileReader();
    reader.readAsDataURL(file);

    reader.onload = function () {
      return resolve({
        status: 'success',
        url: reader.result
      });
    };

    reader.onerror = function (error) {
      return resolve({
        status: 'error',
        error: error
      });
    };
  });
}

function getAccept(fileType) {
  switch (fileType) {
    case 'image':
      return '.jpg,.png';

    case 'svg':
      return '.svg';

    case 'office':
      return '.doc,.docx,.pdf,.xls,.xlsx';

    case 'zip':
      return '.rar,.zip';

    default:
      return '.rar,.zip,.doc,.docx,.pdf,.jpg,.png';
  }
}

var Uploader = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$isOnly = props.isOnly,
      isOnly = _props$isOnly === void 0 ? false : _props$isOnly,
      value = props.value,
      fileType = props.fileType,
      extraExt = props.extraExt,
      children = props.children,
      _props$size = props.size,
      size = _props$size === void 0 ? 2 * 1024 * 1024 : _props$size,
      _props$className = props.className,
      className = _props$className === void 0 ? '' : _props$className,
      _props$onChange = props.onChange,
      onChange = _props$onChange === void 0 ? function () {} : _props$onChange; // 图片预览数据

  var _useState = useState({
    visible: false,
    url: ''
  }),
      _useState2 = _slicedToArray(_useState, 2),
      showConfig = _useState2[0],
      setShowConfig = _useState2[1]; // 用于展示的缩略图


  var _useState3 = useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      fileList = _useState4[0],
      setFileList = _useState4[1];

  useEffect(function () {
    if (!value) {
      setFileList([]);
      return;
    }

    if (Object.prototype.toString.call(value) === '[object Array]') {
      setFileList(value.map(function (file, index) {
        file.uid = index;
        file.url = file.downloadUrl;
        return file;
      }));
      return;
    }

    if (Object.prototype.toString.call(value) === '[object Object]') {
      setFileList([_objectSpread({
        uid: 0,
        url: value.downloadUrl
      }, value)]);
      return;
    }

    if (Object.prototype.toString.call(value) === '[object String]') {
      setFileList([{
        uid: 0,
        url: value,
        name: '附件'
      }]);
      return;
    }
  }, [value]); // 点击文件链接或预览图标时的回调

  var handlePreview = useCallback( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(file) {
      var res;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(!file.url && !file.preview)) {
                _context.next = 5;
                break;
              }

              _context.next = 3;
              return getBase64(file.originFileObj);

            case 3:
              res = _context.sent;

              if (res.status === 'success') {
                file.preview = res.url;
              }

            case 5:
              setShowConfig({
                visible: true,
                url: file.url || file.preview
              });

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }(), [setShowConfig]); // 渲染预览窗口

  var renderPreviewComponent = useMemo(function () {
    if (fileType === 'image' || fileType === 'svg') {
      var visible = showConfig.visible,
          url = showConfig.url;
      return /*#__PURE__*/React.createElement(StandardModal, {
        visible: visible,
        footer: null,
        hideFooter: true,
        onCancel: function onCancel() {
          return setShowConfig({
            visible: false,
            url: ''
          });
        }
      }, /*#__PURE__*/React.createElement("div", {
        style: {
          textAlign: 'center'
        }
      }, /*#__PURE__*/React.createElement("img", {
        style: {
          maxWidth: '100%'
        },
        src: url,
        alt: ""
      })));
    }

    return null;
  }, [fileType, showConfig, setShowConfig]); // 展示按钮与否

  var renderChildrenComponent = useMemo(function () {
    var renderButton = function renderButton() {
      if (fileType === 'image' || fileType === 'svg') {
        return /*#__PURE__*/React.createElement("div", {
          className: 'spec-uploader-control'
        }, /*#__PURE__*/React.createElement(PlusOutlined, null), /*#__PURE__*/React.createElement("div", {
          className: "ant-upload-text"
        }, "\u70B9\u51FB\u9009\u62E9"));
      }

      return /*#__PURE__*/React.createElement(_Button, {
        className: 'spec-uploader-button'
      }, /*#__PURE__*/React.createElement(PlusOutlined, null), "\u70B9\u51FB\u9009\u62E9");
    };

    if (children) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, " ", children, " ");
    }

    if (isOnly && fileList.length === 1) {
      return null;
    }

    return /*#__PURE__*/React.createElement(React.Fragment, null, renderButton());
  }, [fileType, isOnly, children, fileList]); // 检查文件是否规范

  var handleCheck = useCallback(function (file) {
    // if (fileType === 'image') {
    //   const isImage = file.type === 'image/jpeg' || file.type === 'image/png';
    //   if (!isImage) {
    //     message.error('只支持JPG/PNG格式的图片!');
    //     return false;
    //   }
    // }
    // if (fileType === 'svg' && !extraExt) {
    //   const isSVG = file.type === 'image/svg+xml';
    //   if (!isSVG) {
    //     message.error('只支持SVG格式的图片!');
    //     return false;
    //   }
    // }
    var isLt2M = file.size < size;

    if (!isLt2M) {
      _message.error('文件大小不能超过2MB!');

      return false;
    }

    return true;
  }, [fileType, size]);
  var handleChange = useCallback( /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(res) {
      var isOk, result, list;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(res.file.status === 'removed')) {
                _context2.next = 4;
                break;
              }

              setFileList(res.fileList);

              if (isOnly) {
                onChange(res.fileList[0] && res.fileList[0].originFileObj);
              } else {
                onChange(res.fileList);
              }

              return _context2.abrupt("return");

            case 4:
              isOk = handleCheck(res.file);

              if (isOk) {
                list = res.fileList.map(function (file) {
                  if (!file.url) {
                    file.url = file.thumbUrl;
                  }

                  return file;
                });
                result = _toConsumableArray(list);
                setFileList(list);

                if (isOnly) {
                  onChange(result[0] && result[0].originFileObj);
                } else {
                  onChange(result);
                }
              }

            case 6:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }(), [isOnly, onChange, handleCheck, setFileList]);
  var accept = useMemo(function () {
    var res = getAccept(fileType);

    if (extraExt) {
      res = res + ',' + extraExt;
    }

    return res;
  }, [fileType, extraExt]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Upload, _extends({}, props, {
    ref: ref,
    accept: accept,
    fileList: fileList,
    listType: fileType === 'image' || fileType === 'svg' ? 'picture-card' : 'text',
    className: "spec-uploader ".concat(className),
    onPreview: fileType === 'image' || fileType === 'svg' ? handlePreview : function () {},
    beforeUpload: function beforeUpload() {
      return false;
    },
    onChange: handleChange
  }), renderChildrenComponent), renderPreviewComponent);
});
export default Uploader;