function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import './index.less';

function Pane(props) {
  var size = props.size || 0;
  var unit = props.percentage ? '%' : 'px';
  var classes = "".concat(props.paneClassName, " layout-pane ");
  var style = {};

  if (!props.primary) {
    if (props.vertical) {
      style.height = "".concat(size).concat(unit);
    } else {
      style.width = "".concat(size).concat(unit);
    }
  } else {
    classes += ' layout-pane-primary';
  }

  return /*#__PURE__*/React.createElement("div", {
    className: classes,
    style: _objectSpread(_objectSpread({}, props.paneStyle), style)
  }, props.children);
}

Pane.propTypes = {
  paneClassName: PropTypes.string,
  paneStyle: PropTypes.object,
  vertical: PropTypes.bool,
  primary: PropTypes.bool,
  size: PropTypes.number,
  percentage: PropTypes.bool,
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};
Pane.defaultProps = {
  paneClassName: '',
  vertical: false,
  primary: false,
  size: 0,
  percentage: false,
  children: []
};
export default Pane;