function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

import "antd/es/dropdown/style";
import _Dropdown from "antd/es/dropdown";
import "antd/es/menu/style";
import _Menu from "antd/es/menu";
import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/form/style";
import _Form from "antd/es/form";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

import React, { useEffect, useState } from 'react';
import _ from 'lodash';
import FieldComponent from '../FormComp/FieldComponent';
import UtilValueFormat from '../utils/ValueFormat.js';
import { IconNode } from '../components';
import SpecIcon from '../SpecIconFont';
import { funcCode, general } from '../data/index';
import './index.less';
var FormItem = _Form.Item;

var StandardFilter = /*#__PURE__*/function (_React$Component) {
  _inherits(StandardFilter, _React$Component);

  var _super = _createSuper(StandardFilter);

  _createClass(StandardFilter, null, [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      var buttonGroup = nextProps.buttonGroup,
          formItemGroup = nextProps.formItemGroup;
      return {
        recombinationGroup: Array.isArray(buttonGroup) ? buttonGroup.filter(function (item) {
          return item && !item.isHide;
        }) : buttonGroup,
        reFormItemGroup: formItemGroup
      };
    }
  }]);

  function StandardFilter(props) {
    var _this;

    _classCallCheck(this, StandardFilter);

    _this = _super.call(this, props);
    _this.filterFormRef = /*#__PURE__*/React.createRef();

    _this.updateFormFields = function (newVal) {
      var getFormFields = _this.props.getFormFields;
      if (newVal) _this.filterFormRef.current.setFieldsValue(_objectSpread({}, newVal));
      if (getFormFields) getFormFields(_this.filterFormRef.current.getFieldsValue(), _this.filterFormRef);
    };

    _this.handleSearch = function (values) {
      var _this$props = _this.props,
          formItemGroup = _this$props.formItemGroup,
          onFilterSearch = _this$props.onFilterSearch;

      if (Object.prototype.hasOwnProperty.call(values, false)) {
        delete values.false; // TODO 自定义结构会莫名的出来一个false字段
      }

      var resultValues = UtilValueFormat(values, formItemGroup);

      if (onFilterSearch) {
        onFilterSearch(_objectSpread({}, resultValues));
      }
    };

    _this.handleReset = function () {
      var onFilterReset = _this.props.onFilterReset; // 使用此方法，表单校验无法清空掉

      var resetValues = _this.filterFormRef.current.getFieldsValue();

      Object.keys(resetValues).forEach(function (item) {
        resetValues[item] = undefined;
      });

      _this.filterFormRef.current.setFieldsValue(_objectSpread({}, resetValues)); // 直接清空表单的赋值
      // this.filterFormRef.current.resetFields()


      _this.setState({
        reFormItemGroup: _this.props.formItemGroup // 重新渲染列表

      });

      if (onFilterReset) {
        onFilterReset(_this.filterFormRef.current.getFieldsValue());
      }
    };

    _this.itemIsHide = function (isHide) {
      var current = _this.filterFormRef.current;
      if (!isHide) return false;

      if (typeof isHide === 'function') {
        return isHide(current ? current.getFieldsValue() : {}, current);
      }

      return isHide;
    };

    _this.renderFormItemGroup = function () {
      var reFormItemGroup = _this.state.reFormItemGroup;

      if (Array.isArray(reFormItemGroup)) {
        return /*#__PURE__*/React.createElement(React.Fragment, null, reFormItemGroup.map(function (item, index) {
          var componentStyle = item.componentStyle,
              isHide = item.isHide;
          if (_this.itemIsHide(isHide)) return null;
          return /*#__PURE__*/React.createElement(FormItem, _extends({
            key: item.filedName,
            label: item.label,
            name: item.type !== 'custom' && item.filedName,
            rules: item.rules || (item.fieldOptions ? item.fieldOptions.rules : [])
          }, item.protoFormItem), item.type === 'custom' && item.customRender ? item.customRender(_this.filterFormRef, _objectSpread({}, item)) : /*#__PURE__*/React.createElement(FieldComponent, _extends({}, item, {
            onChange: function onChange(val) {
              var updateValue = val;

              if (item.type === 'input' || item.type === 'textarea' || item.type === 'radio') {
                updateValue = val.target.value;
              }

              _this.updateFormFields(_defineProperty({}, item.filedName, updateValue));

              if (item.onChange) item.onChange(val, _this.filterFormRef);
            },
            style: _objectSpread({
              width: item.type === 'checkbox' || item.type === 'radio' ? 'auto' : general.formItemStyle.xsm.width
            }, componentStyle)
          })));
        }));
      }

      return reFormItemGroup;
    };

    _this.renderButtonGroup = function () {
      var recombinationGroup = _this.state.recombinationGroup; // const { getFieldsValue } = form;
      // const fields = getFieldsValue();

      var btn = function btn(item, index) {
        if (item.render) return item.render;

        if (item.code && _.findIndex(funcCode.btnFuncCodes, function (btnItem) {
          return btnItem.code === item.code;
        }) !== -1) {
          // 如果有配置code，则使用func.code.js里面配置的名称
          item = Object.assign(item, funcCode.btnFuncCodes[_.findIndex(funcCode.btnFuncCodes, function (btnItem) {
            return btnItem.code === item.code;
          })]);
        }

        return /*#__PURE__*/React.createElement(_Button, {
          key: index,
          type: item.type ? item.type : 'primary',
          danger: item.danger,
          icon: /*#__PURE__*/React.createElement(IconNode, {
            icon: item.icon
          }),
          disabled: item.disabled,
          onClick: item.fn ? function (e) {
            return item.fn(item, _this.filterFormRef.current.getFieldsValue(), e);
          } : null
        }, item.exName || item.name);
      };

      var menu = function menu(group) {
        return /*#__PURE__*/React.createElement(_Menu, null, group.map(function (item) {
          if (item.code && _.findIndex(funcCode.btnFuncCodes, function (btnItem) {
            return btnItem.code === item.code;
          }) !== -1) {
            // 如果有配置code，则使用func.code.js里面配置的名称
            item = Object.assign(item, funcCode.btnFuncCodes[_.findIndex(funcCode.btnFuncCodes, function (btnItem) {
              return btnItem.code === item.code;
            })]);
          }

          return /*#__PURE__*/React.createElement(_Menu.Item, {
            key: item.name
          }, /*#__PURE__*/React.createElement("a", {
            onClick: item.fn ? function () {
              return item.fn(item);
            } : null
          }, /*#__PURE__*/React.createElement(IconNode, {
            icon: item.icon
          }), " ", item.exName || item.name));
        }));
      }; // 判断是否是数组且长度大于0时 ？{如下结构渲染} ： {按buttonGroup返回的node渲染}


      if (Array.isArray(recombinationGroup)) {
        // 判断提供数据长度是否大于3，如果超过3个，则后面从第4个开始会在dropdown组件中渲染
        if (recombinationGroup.length > 3) {
          var forGroup = recombinationGroup.slice(0, 2);
          var forDrop = recombinationGroup.slice(2);
          return /*#__PURE__*/React.createElement(React.Fragment, null, forGroup.map(function (item, index) {
            return index < 2 ? btn(item, index) : null;
          }), /*#__PURE__*/React.createElement(_Dropdown, {
            overlay: menu(forDrop),
            placement: "bottomRight"
          }, /*#__PURE__*/React.createElement(_Button, {
            type: "primary"
          }, "\u66F4\u591A ", /*#__PURE__*/React.createElement(SpecIcon, {
            name: "down"
          }))));
        }

        return /*#__PURE__*/React.createElement(React.Fragment, null, recombinationGroup.map(function (item, index) {
          return btn(item, index);
        }));
      }

      return recombinationGroup;
    };

    _this.state = {
      recombinationGroup: undefined,
      reFormItemGroup: undefined
    };
    return _this;
  }

  _createClass(StandardFilter, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.updateFormFields();
    } // 更新表单控件值，用于外部获取当前表单实例

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          initialValues = _this$props2.initialValues,
          formItemGroup = _this$props2.formItemGroup,
          onFilterReset = _this$props2.onFilterReset;
      var recombinationGroup = this.state.recombinationGroup;
      return /*#__PURE__*/React.createElement(_Form, {
        name: "standard-filter-form",
        ref: this.filterFormRef,
        layout: "inline",
        onFinish: this.handleSearch,
        className: className,
        style: style,
        initialValues: _objectSpread({}, initialValues)
      }, /*#__PURE__*/React.createElement("div", {
        className: "filter-grid"
      }, /*#__PURE__*/React.createElement("div", {
        className: "filter-form"
      }, this.state.reFormItemGroup ? /*#__PURE__*/React.createElement(React.Fragment, null, this.renderFormItemGroup(), /*#__PURE__*/React.createElement(FormItem, null, /*#__PURE__*/React.createElement(_Button, {
        type: "primary",
        htmlType: "submit"
      }, "\u67E5\u8BE2"), onFilterReset && /*#__PURE__*/React.createElement(_Button, {
        type: "primary",
        style: {
          marginLeft: 8
        },
        onClick: this.handleReset,
        ghost: true
      }, "\u91CD\u7F6E"))) : null), recombinationGroup ? /*#__PURE__*/React.createElement("div", {
        className: "filter-btns",
        style: Array.isArray(recombinationGroup) && recombinationGroup.length === 0 ? {
          display: 'none'
        } : {}
      }, this.renderButtonGroup()) : null));
    }
  }]);

  return StandardFilter;
}(React.Component);

export default StandardFilter;