import "antd/es/button/style";
import _Button from "antd/es/button";
import React, { useEffect, useState, useRef, useMemo } from 'react';
import IconNode from "../components/IconNode";

var ActionList = function ActionList(props) {
  var list = props.list,
      form = props.form,
      align = props.align,
      other = props.other,
      onStep = props.onStep;
  return /*#__PURE__*/React.createElement("div", {
    className: "standardForm-actions",
    style: {
      textAlign: align
    }
  }, list.map(function (item, index) {
    return /*#__PURE__*/React.createElement(_Button, {
      key: index,
      type: item.type ? item.type : 'primary',
      icon: /*#__PURE__*/React.createElement(IconNode, {
        icon: item.icon
      }),
      ghost: item.ghost,
      disabled: item.disabled,
      loading: item.loading,
      onClick: function onClick(e) {
        if (item.action) {
          // 如果有配置默认执行方法，则优先以组件内部的步骤事件做处理
          onStep(item.action, function () {
            item.fn && item.fn(item, form, other, e);
          });
        } else if (item.fn) {
          item.fn(item, form, other, e);
        } else if (item.onClick) {
          item.onClick(item, form, other, e);
        }
      }
    }, item.name);
  }));
};

export default ActionList;