import "antd/es/col/style";
import _Col from "antd/es/col";
import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/steps/style";
import _Steps from "antd/es/steps";

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useState, useRef, useMemo } from 'react';
import './index.less';
import StandardForm from './index';
import RenderItemGroup from '../FormComp/RenderItemGroup';
import ActionList from "./ActionList";
var Step = _Steps.Step;
var StepForm = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var getFormFields = props.getFormFields,
      _props$formItemGroup = props.formItemGroup,
      formItemGroup = _props$formItemGroup === void 0 ? [] : _props$formItemGroup,
      _props$stepsConfig = props.stepsConfig,
      stepsConfig = _props$stepsConfig === void 0 ? {
    current: 0
  } : _props$stepsConfig,
      stepClick = props.stepClick,
      grid = props.grid,
      layout = props.layout,
      onSubmit = props.onSubmit,
      _props$actionAlign = props.actionAlign,
      actionAlign = _props$actionAlign === void 0 ? 'center' : _props$actionAlign,
      actionHide = props.actionHide,
      fieldStatus = props.fieldStatus,
      initialValues = props.initialValues;

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      formChildFields = _useState2[0],
      setFormChildFields = _useState2[1];

  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      formChild = _useState4[0],
      setFormChild = _useState4[1];

  var _useState5 = useState(0),
      _useState6 = _slicedToArray(_useState5, 2),
      currentStep = _useState6[0],
      setCurrentStep = _useState6[1];

  var _useState7 = useState(false),
      _useState8 = _slicedToArray(_useState7, 2),
      fieldFailed = _useState8[0],
      setFieldFailed = _useState8[1];

  useEffect(function () {
    if (stepsConfig && (stepsConfig.current || stepsConfig.current === 0)) {
      setCurrentStep(stepsConfig.current); // 判断是否有设置当前选中的步骤数
    }
  }, [stepsConfig]);
  if (formItemGroup.length === 0) return null;
  var formGridSize = useMemo(function () {
    if (typeof grid === 'string') return grid; // 数据格式为字符串，包括 xs,md,lg,xlg

    var sizeName = 'xs';
    if (grid <= 1) sizeName = 'xs';
    if (grid === 2) sizeName = 'md';
    if (grid === 3) sizeName = 'lg';
    if (grid > 3) sizeName = 'xlg';
    return sizeName;
  }, [grid]);
  useEffect(function () {
    forceUpdateForm();
  }, [formChildFields, formChild]);

  var forceUpdateForm = function forceUpdateForm() {
    getFormFields && getFormFields(formChildFields, formChild);
  };

  var handleStepType = function handleStepType(type, extraFunc) {
    switch (type) {
      case 'submit':
      case 'next':
        // 获取当前步骤的表单配置下有 rules 的控件进行校验（自定义的控件则自己有业务层面处理添加校验）
        var curentFields = formItemGroup[currentStep].fields;
        var valitorGroup = curentFields && Array.isArray(curentFields) ? curentFields.filter(function (fItem) {
          return fItem.rules;
        }).map(function (matchItem) {
          return matchItem.filedName;
        }) : [];
        formChild.validateFields(valitorGroup).then(function (values) {
          if (stepClick) stepClick(type, formChild, values);
          extraFunc && extraFunc();
        }).catch(function (_ref) {// console.log('表单校验不通过 ', errorFields.map(err => err))

          var errorFields = _ref.errorFields;
        });
        break;

      case 'prev':
        if (stepClick) stepClick(type, formChild);
        extraFunc && extraFunc();
        break;

      case 'cancel':
        if (stepClick) stepClick(type, formChild);
        extraFunc && extraFunc();
        break;

      default:
        break;
    }
  };

  var handleStepChange = function handleStepChange(cur) {
    // 自行判断是否校验通过

    /*    if (cur > current) {
          formChild.validateFields()
            .then(values => {
              if (stepsConfig && stepsConfig.onChange) stepsConfig.onChange(cur, formChild);
            })
            .catch(errorInfo => {
            });
        } else {
          if (stepsConfig && stepsConfig.onChange) stepsConfig.onChange(cur, formChild);
        }*/
    if (stepsConfig && stepsConfig.onChange) stepsConfig.onChange(cur, formChild);
  };

  var renderStepActions = function renderStepActions(item, index) {
    if (formItemGroup.length === 1) {
      /*#__PURE__*/
      React.createElement("div", {
        className: "standardForm-actions",
        key: index
      }, /*#__PURE__*/React.createElement(_Button, {
        type: "primary",
        htmlType: "submit",
        onClick: function onClick() {
          return handleStepType('submit');
        }
      }, "\u786E\u8BA4"), /*#__PURE__*/React.createElement(_Button, {
        onClick: function onClick() {
          return handleStepType('cancel');
        }
      }, "\u53D6\u6D88"));
    }

    var buttonList = function buttonList(itemIndex) {
      if (itemIndex === 0) {
        return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, {
          type: "primary",
          onClick: function onClick() {
            return handleStepType('next');
          }
        }, "\u4E0B\u4E00\u6B65"), /*#__PURE__*/React.createElement(_Button, {
          onClick: function onClick() {
            return handleStepType('cancel');
          }
        }, "\u53D6\u6D88"));
      } else if (itemIndex === formItemGroup.length - 1) {
        return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, {
          type: "primary",
          onClick: function onClick() {
            return handleStepType('prev');
          }
        }, "\u4E0A\u4E00\u6B65"), /*#__PURE__*/React.createElement(_Button, {
          type: "primary",
          htmlType: "submit",
          onClick: function onClick() {
            return handleStepType('submit');
          }
        }, "\u786E\u8BA4"), /*#__PURE__*/React.createElement(_Button, {
          onClick: function onClick() {
            return handleStepType('cancel');
          }
        }, "\u53D6\u6D88"));
      } else {
        return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, {
          type: "primary",
          onClick: function onClick() {
            return handleStepType('prev');
          }
        }, "\u4E0A\u4E00\u6B65"), /*#__PURE__*/React.createElement(_Button, {
          type: "primary",
          onClick: function onClick() {
            return handleStepType('next');
          }
        }, "\u4E0B\u4E00\u6B65"), /*#__PURE__*/React.createElement(_Button, {
          onClick: function onClick() {
            return handleStepType('cancel');
          }
        }, "\u53D6\u6D88"));
      }
    };

    return /*#__PURE__*/React.createElement("div", {
      className: "standardForm-actions",
      key: index,
      style: {
        textAlign: actionAlign
      }
    }, buttonList(index));
  };

  return /*#__PURE__*/React.createElement(StandardForm, {
    className: layout === 'inline' ? '' : '',
    actionGroup: [],
    ref: ref,
    initialValues: initialValues,
    getFormFields: function getFormFields(fields, form) {
      setFormChildFields(fields);
      setFormChild(form);
    },
    onSubmit: onSubmit,
    layout: layout,
    onFinishFailed: function onFinishFailed() {
      return setFieldFailed(true);
    }
  }, /*#__PURE__*/React.createElement(_Steps, stepsConfig, formItemGroup.map(function (item, index) {
    return !item.hideStep ? /*#__PURE__*/React.createElement(Step, {
      key: "".concat(item.title).concat(index),
      description: item.description,
      icon: item.icon,
      status: item.status,
      title: item.title,
      subTitle: item.subTitle,
      disabled: item.disabled
    }) : null;
  })), formItemGroup.map(function (item, index) {
    return /*#__PURE__*/React.createElement("div", {
      key: index,
      className: "stepForm-content ".concat(layout === 'inline' ? 'stepForm-content-inline' : ''),
      style: stepsConfig && stepsConfig.current !== index ? {
        display: 'none'
      } : {}
    }, item.fields && Array.isArray(item.fields) ? /*#__PURE__*/React.createElement(RenderItemGroup, {
      layout: layout,
      form: formChild,
      fieldStatus: fieldStatus,
      size: formGridSize // doUpdateFormFields={() => console.log('强制渲染表单')}
      ,
      itemGroup: item.fields
    }) : item.fields, !actionHide && /*#__PURE__*/React.createElement(_Col, {
      span: 24
    }, item.actions ? /*#__PURE__*/React.createElement(ActionList, {
      list: item.actions,
      onStep: handleStepType,
      form: formChild,
      align: actionAlign,
      other: props
    }) : renderStepActions(item, index)));
  }));
});
export default StepForm;