import "antd/es/col/style";
import _Col from "antd/es/col";
import "antd/es/tabs/style";
import _Tabs from "antd/es/tabs";
import "antd/es/steps/style";
import _Steps from "antd/es/steps";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useEffect, useState, useRef, useMemo } from 'react';
import './index.less';
import StandardForm from './index';
import RenderItemGroup from '../FormComp/RenderItemGroup';
import IconNode from "../components/IconNode";
import ActionList from "./ActionList";
var Step = _Steps.Step;
var TabPane = _Tabs.TabPane;
var TabForm = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var getFormFields = props.getFormFields,
      _props$formItemGroup = props.formItemGroup,
      formItemGroup = _props$formItemGroup === void 0 ? [] : _props$formItemGroup,
      tabsConfig = props.tabsConfig,
      grid = props.grid,
      layout = props.layout,
      _props$actionAlign = props.actionAlign,
      actionAlign = _props$actionAlign === void 0 ? 'center' : _props$actionAlign,
      actionHide = props.actionHide,
      fieldStatus = props.fieldStatus,
      onSubmit = props.onSubmit,
      initialValues = props.initialValues;

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      formChildFields = _useState2[0],
      setFormChildFields = _useState2[1];

  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      formChild = _useState4[0],
      setFormChild = _useState4[1];

  var _useState5 = useState(0),
      _useState6 = _slicedToArray(_useState5, 2),
      currentStep = _useState6[0],
      setCurrentStep = _useState6[1]; // const [fieldFailed, setFieldFailed] = useState(false)


  if (formItemGroup.length === 0) return null;

  var renderGroup = function renderGroup(list) {};

  var formGridSize = useMemo(function () {
    if (typeof grid === 'string') return grid; // 数据格式为字符串，包括 xs,md,lg,xlg

    var sizeName = 'xs';
    if (grid <= 1) sizeName = 'xs';
    if (grid === 2) sizeName = 'md';
    if (grid === 3) sizeName = 'lg';
    if (grid > 3) sizeName = 'xlg';
    return sizeName;
  }, [grid]);
  useEffect(function () {
    forceUpdateForm();
  }, [formChildFields, formChild]);

  var forceUpdateForm = function forceUpdateForm() {
    console.log('TabForm强制更新表单控件');
    getFormFields && getFormFields(formChildFields, formChild);
  };

  var handleStepType = function handleStepType(type) {
    switch (type) {
      case 'next':
        formChild.validateFields().then(function (values) {
          setCurrentStep(currentStep + 1);
        }).catch(function (errorInfo) {});
        break;

      case 'prev':
        setCurrentStep(currentStep - 1);
        break;

      case 'submit':
        break;

      case 'cancel':
        break;

      default:
        break;
    }
  };

  return /*#__PURE__*/React.createElement(StandardForm, {
    actionGroup: [],
    ref: ref,
    getFormFields: function getFormFields(fields, form) {
      setFormChildFields(fields);
      setFormChild(form);
    },
    layout: layout,
    onSubmit: onSubmit,
    initialValues: initialValues
  }, /*#__PURE__*/React.createElement(_Tabs, _extends({
    type: "card",
    animated: false
  }, tabsConfig), formItemGroup.map(function (item, index) {
    var title = item.title,
        fields = item.fields,
        actions = item.actions,
        tabConfig = _objectWithoutProperties(item, ["title", "fields", "actions"]);

    return /*#__PURE__*/React.createElement(TabPane, _extends({
      key: "".concat(item.key || index),
      tab: title
    }, tabConfig, {
      forceRender: true
    }), /*#__PURE__*/React.createElement("div", {
      className: "tabForm-content ".concat(layout === 'inline' ? 'tabForm-content-inline' : '')
    }, fields && Array.isArray(fields) ? /*#__PURE__*/React.createElement(RenderItemGroup, {
      layout: layout,
      form: formChild,
      fieldStatus: fieldStatus,
      size: formGridSize // doUpdateFormFields={() => forceUpdateForm()}
      ,
      itemGroup: fields
    }) : fields, !actionHide && actions && /*#__PURE__*/React.createElement(_Col, {
      span: 24
    }, /*#__PURE__*/React.createElement(ActionList, {
      list: item.actions,
      form: formChild,
      other: props,
      align: actionAlign
    }))));
  })));
});
export default TabForm;