import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/form/style";
import _Form from "antd/es/form";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect, useMemo } from 'react';
import classNames from 'classnames';
import RenderItemGroup from '../FormComp/RenderItemGroup';
import { general } from '../data/index';
import './index.less';
import ActionList from "./ActionList";
var StandardForm = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$formItemGroup = props.formItemGroup,
      formItemGroup = _props$formItemGroup === void 0 ? [] : _props$formItemGroup,
      className = props.className,
      initialValues = props.initialValues,
      _props$layout = props.layout,
      layout = _props$layout === void 0 ? 'horizontal' : _props$layout,
      _props$grid = props.grid,
      grid = _props$grid === void 0 ? 1 : _props$grid,
      autoSize = props.autoSize,
      getFormFields = props.getFormFields,
      fieldStatus = props.fieldStatus,
      onSubmit = props.onSubmit,
      _props$confirmText = props.confirmText,
      confirmText = _props$confirmText === void 0 ? '确认' : _props$confirmText,
      onCancel = props.onCancel,
      _props$cancelText = props.cancelText,
      cancelText = _props$cancelText === void 0 ? '取消' : _props$cancelText,
      actionAlign = props.actionAlign,
      actionGroup = props.actionGroup,
      onFinishFailed = props.onFinishFailed,
      children = props.children,
      baseProps = _objectWithoutProperties(props, ["formItemGroup", "className", "initialValues", "layout", "grid", "autoSize", "getFormFields", "fieldStatus", "onSubmit", "confirmText", "onCancel", "cancelText", "actionAlign", "actionGroup", "onFinishFailed", "children"]);

  var _Form$useForm = _Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      initForm = _Form$useForm2[0];

  var gridSize = useMemo(function () {
    var sizeName = 'xs';
    if (grid <= 1) sizeName = 'xs';
    if (grid === 2) sizeName = 'md';
    if (grid === 3) sizeName = 'lg';
    if (grid > 3) sizeName = 'xlg';
    return sizeName;
  }, [grid]);
  var actionAlignCol = useMemo(function () {
    if (layout !== 'horizontal' || gridSize !== 'xs' || actionAlign) {
      return {};
    }

    return _objectSpread(_objectSpread({}, general.modalSize[gridSize].formBlockLayout.wrapperCol), {}, {
      offset: general.modalSize[gridSize].formBlockLayout.labelCol.span
    });
  }, [layout, gridSize, actionAlign]);
  useEffect(function () {
    if (initForm) {
      // <---- check ref before use the form instance
      forceUpdateForm();
    }
  }, [initForm]); // 强制更新表单值，用于赋初始化实例值

  var forceUpdateForm = function forceUpdateForm() {
    getFormFields && getFormFields(initForm.getFieldsValue() || {}, initForm);
  };

  var onFormFinish = function onFormFinish(values) {
    if (onSubmit) onSubmit(values);
  };

  var onFormFinishFailed = function onFormFinishFailed(_ref) {
    var values = _ref.values,
        errorFields = _ref.errorFields,
        outOfDate = _ref.outOfDate;
    // 定位到第一条表单异常的焦点
    var errorCollection = Array.prototype.slice.call(document.getElementsByClassName('ant-form-item-has-error'));

    if (errorCollection[0] && errorCollection[0].getElementsByTagName('input')) {
      Array.prototype.slice.call(errorCollection[0].getElementsByTagName('input'))[0].focus();
    }

    if (onFinishFailed) onFinishFailed({
      values: values,
      errorFields: errorFields,
      outOfDate: outOfDate
    });
  };

  var onFormCancel = function onFormCancel() {
    if (onCancel) onCancel();
  }; // 按钮组


  var renderActionGroup = function renderActionGroup() {
    var groupNode = function groupNode() {
      if (Array.isArray(actionGroup)) {
        return actionGroup.length === 0 ? null : /*#__PURE__*/React.createElement(_Form.Item, {
          wrapperCol: actionAlignCol
        }, /*#__PURE__*/React.createElement(ActionList, {
          list: actionGroup,
          form: initForm,
          align: actionAlign,
          other: props
        }));
      }

      return actionGroup;
    };

    if (Array.isArray(actionGroup) && actionGroup.length === 0) return null;
    if (actionGroup) return groupNode();
    return /*#__PURE__*/React.createElement(_Form.Item, {
      className: "standardForm-actions",
      style: {
        textAlign: actionAlign
      },
      wrapperCol: actionAlignCol
    }, confirmText && /*#__PURE__*/React.createElement(_Button, {
      type: "primary",
      htmlType: "submit"
    }, confirmText), cancelText && /*#__PURE__*/React.createElement(_Button, {
      onClick: function onClick() {
        return onFormCancel();
      }
    }, cancelText));
  };

  return /*#__PURE__*/React.createElement(_Form, _extends({
    className: classNames(className, 'standardForm'),
    ref: ref,
    form: initForm,
    initialValues: initialValues,
    layout: layout
  }, baseProps, {
    onFinish: onFormFinish,
    onFinishFailed: onFormFinishFailed,
    scrollToFirstError: true
  }), children, /*#__PURE__*/React.createElement(React.Fragment, null, formItemGroup.length > 0 ? /*#__PURE__*/React.createElement(RenderItemGroup, {
    itemGroup: formItemGroup // doUpdateFormFields={() => forceUpdateForm()}
    ,
    size: gridSize,
    layout: layout,
    fieldStatus: fieldStatus
  }) : null, renderActionGroup()));
});
export default StandardForm;