import "antd/es/modal/style";
import _Modal from "antd/es/modal";
import "antd/es/row/style";
import _Row from "antd/es/row";
import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/form/style";
import _Form from "antd/es/form";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect, useState, useRef } from 'react';
import './index.less';
import { general } from '../data';
import RenderItemGroup from '../FormComp/RenderItemGroup';
import UtilValueFormat from '../utils/ValueFormat.js';
import IconNode from "../components/IconNode";
import TabForm from '../StandardForm/TabForm.js';
import StepForm from '../StandardForm/StepForm.js';
import ActionList from '../StandardForm/ActionList.js';

var StandardModalFunc = function StandardModalFunc(props) {
  var children = props.children,
      className = props.className,
      style = props.style,
      _props$size = props.size,
      size = _props$size === void 0 ? 'md' : _props$size,
      type = props.type,
      formItemGroup = props.formItemGroup,
      title = props.title,
      visible = props.visible,
      formPrefix = props.formPrefix,
      formPostfix = props.formPostfix,
      initialValues = props.initialValues,
      hideRequiredMark = props.hideRequiredMark,
      footer = props.footer,
      footerButtonGroup = props.footerButtonGroup,
      bodyStyle = props.bodyStyle,
      _props$hideFooter = props.hideFooter,
      hideFooter = _props$hideFooter === void 0 ? false : _props$hideFooter,
      _getFormFields = props.getFormFields,
      _props$fieldStatus = props.fieldStatus,
      fieldStatus = _props$fieldStatus === void 0 ? 'default' : _props$fieldStatus,
      _props$formLayout = props.formLayout,
      formLayout = _props$formLayout === void 0 ? 'horizontal' : _props$formLayout,
      tabsConfig = props.tabsConfig,
      stepsConfig = props.stepsConfig,
      otherProps = _objectWithoutProperties(props, ["children", "className", "style", "size", "type", "formItemGroup", "title", "visible", "formPrefix", "formPostfix", "initialValues", "hideRequiredMark", "footer", "footerButtonGroup", "bodyStyle", "hideFooter", "getFormFields", "fieldStatus", "formLayout", "tabsConfig", "stepsConfig"]);

  var _Form$useForm = _Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      modalForm = _Form$useForm2[0];

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      modalFormRef = _useState2[0],
      setModalFormRef = _useState2[1]; // <---- set the ref when Form Rendered


  var _useState3 = useState(0),
      _useState4 = _slicedToArray(_useState3, 2),
      bodyMaxHeight = _useState4[0],
      setBodyMaxHeight = _useState4[1]; // setTabFormChild


  var _useState5 = useState(),
      _useState6 = _slicedToArray(_useState5, 2),
      formChild = _useState6[0],
      setFormChild = _useState6[1]; // <---- set the ref when Form Rendered
  // console.log(创建表单实际)


  var initBodyMaxHeight = function initBodyMaxHeight() {
    var title = props.title,
        hideFooter = props.hideFooter,
        fieldStatus = props.fieldStatus;
    setBodyMaxHeight("".concat(document.body.offsetHeight - (title ? 55 : 0) - (footer || footerButtonGroup ? 55 : 0) - 150 - 32 + (fieldStatus && fieldStatus !== 'default' || hideFooter ? 65 : 0), "px"));
  }; // fill Form when modal open 此处可解决获取  Form.useForm  warning


  useEffect(function () {
    if (visible && modalFormRef) {
      // <---- check ref before use the form instance
      modalForm.setFieldsValue(_objectSpread({}, initialValues));
      forceUpdateForm();
    } // if (!visible && modalFormRef) {
    // clearAllFieldsValue() // 清空表单传参数
    // }

  }, [modalFormRef, visible]);
  useEffect(function () {
    if (visible) {
      initBodyMaxHeight(); // 让resize事件触发 initBodyMaxHeight

      window.addEventListener('resize', initBodyMaxHeight);
    } else {
      window.removeEventListener('resize', initBodyMaxHeight);
    }
  }, [fieldStatus, title, visible, hideFooter, footer, footerButtonGroup]);

  var handleSubmit = function handleSubmit() {
    var type = props.type,
        formItemGroup = props.formItemGroup,
        onSubmit = props.onSubmit;

    if (type === 'form') {
      modalForm.validateFields().then(function (values) {
        if (Object.prototype.hasOwnProperty.call(values, false)) {
          delete values.false; // TODO 自定义结构会莫名的出来一个false字段
        }

        var resultValues = UtilValueFormat(values, formItemGroup);

        if (onSubmit) {
          onSubmit(_objectSpread({}, resultValues));
        }
      }).catch(function (errorInfo) {
        // 定位到第一条表单异常的
        var errorCollection = Array.prototype.slice.call(document.getElementsByClassName('ant-form-item-has-error'));

        if (errorCollection[0] && errorCollection[0].getElementsByTagName('input')) {
          Array.prototype.slice.call(errorCollection[0].getElementsByTagName('input'))[0].focus();
        } // console.error('表单填写有误', errorInfo, '第一条数据',errorInfo.errorFields[0].name[0])

      });
    } else if (type === 'stepForm' || type === 'tabForm') {
      // onSubmit && onSubmit()
      formChild.validateFields().then(function (values) {
        console.log(values);

        if (Object.prototype.hasOwnProperty.call(values, false)) {
          delete values.false; // TODO 自定义结构会莫名的出来一个false字段
        }

        var resultValues = UtilValueFormat(values, formItemGroup);

        if (onSubmit) {
          onSubmit(_objectSpread({}, resultValues));
        }
      }).catch(function (errorInfo) {
        // 定位到第一条表单异常的
        var errorCollection = Array.prototype.slice.call(document.getElementsByClassName('ant-form-item-has-error'));

        if (errorCollection[0] && errorCollection[0].getElementsByTagName('input')) {
          Array.prototype.slice.call(errorCollection[0].getElementsByTagName('input'))[0].focus();
        } // console.error('表单填写有误', errorInfo, '第一条数据',errorInfo.errorFields[0].name[0])

      });
    } else {
      // 没有表单数组 formItemGroup 配置
      onSubmit && onSubmit();
    }
  }; // 重置所有表单


  var clearAllFieldsValue = function clearAllFieldsValue() {
    // let allFields = {}
    // Object.keys(modalForm.getFieldsValue()).map((item) => allFields[item] = undefined)
    // modalForm.setFieldsValue(allFields) // 直接清空表单的赋值(initialValues传值如果没有前后赋值没有全部带上所有字段，则会默认又使用之前的部分未传参字段)
    modalForm.resetFields(); // 直接使用这个无效
  };

  var onAfterClose = function onAfterClose() {
    var afterClose = props.afterClose;
    if (type === 'form') clearAllFieldsValue();
    if (afterClose) afterClose();
  };

  var handleCancel = function handleCancel() {
    var onCancel = props.onCancel;
    if (onCancel) onCancel();
  }; // 强制更新表单值，用于赋初始化实例值


  var forceUpdateForm = function forceUpdateForm() {
    _getFormFields && _getFormFields(modalForm.getFieldsValue() || {}, modalForm);
  };

  var renderButtonGroup = function renderButtonGroup() {
    var footerButtonGroup = props.footerButtonGroup,
        confirmLoading = props.confirmLoading,
        cancelText = props.cancelText,
        confirmText = props.confirmText,
        okText = props.okText,
        okButtonProps = props.okButtonProps,
        confirmButtonProps = props.confirmButtonProps,
        cancelButtonProps = props.cancelButtonProps;

    if (footerButtonGroup) {
      if (Array.isArray(footerButtonGroup)) {
        if (footerButtonGroup.length === 0) return null;
        return /*#__PURE__*/React.createElement(React.Fragment, null, footerButtonGroup.map(function (item) {
          if (_typeof(item) === 'object') {
            return /*#__PURE__*/React.createElement(_Button, {
              key: item.name,
              type: item.type ? item.type : 'primary',
              icon: /*#__PURE__*/React.createElement(IconNode, {
                icon: item.icon
              }),
              ghost: item.ghost,
              disabled: item.disabled,
              loading: item.loading,
              onClick: item.fn ? function (e) {
                return item.fn(item, modalForm, props, e);
              } : null
            }, item.name);
          } else {
            return item; // 如果是DOM，则直接渲染
          }
        }));
      }

      return footerButtonGroup;
    }

    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_Button, _extends({
      key: "submit",
      type: "primary",
      loading: confirmLoading,
      onClick: handleSubmit
    }, confirmButtonProps, okButtonProps), confirmText || okText || '确定'), /*#__PURE__*/React.createElement(_Button, _extends({
      key: "back",
      onClick: handleCancel
    }, cancelButtonProps), cancelText || '取消'));
  };

  var renderFormItemGroup = function renderFormItemGroup() {
    var fieldStatus = props.fieldStatus,
        formItemGroup = props.formItemGroup,
        _props$size2 = props.size,
        size = _props$size2 === void 0 ? 'md' : _props$size2,
        displayLayout = props.displayLayout;

    if (Array.isArray(formItemGroup)) {
      return /*#__PURE__*/React.createElement(RenderItemGroup, {
        size: size,
        layout: formLayout,
        doUpdateFormFields: function doUpdateFormFields() {
          return forceUpdateForm();
        },
        displayLayout: displayLayout,
        itemGroup: formItemGroup,
        fieldStatus: fieldStatus,
        form: modalForm
      });
    }

    return formItemGroup;
  };

  var handleStepType = function handleStepType(type, extraFunc) {
    var current = stepsConfig.current;

    switch (type) {
      case 'submit':
      case 'next':
        // 获取当前步骤的表单配置下有 rules 的控件进行校验（自定义的控件则自己有业务层面处理添加校验）
        // console.log('执行下一步骤，需要优先进行校验')
        var curentFields = formItemGroup[current].fields;
        var valitorGroup = curentFields && Array.isArray(curentFields) ? curentFields.map(function (fItem) {
          return fItem.rules ? fItem.filedName : null;
        }) : [];
        formChild.validateFields(valitorGroup).then(function (values) {
          // if (stepClick) stepClick(type, formChild, values);
          extraFunc();
        }).catch(function (_ref) {// console.log('表单校验不通过 ', errorFields.map(err => err))

          var errorFields = _ref.errorFields;
        });
        break;

      case 'prev':
        // if (stepClick) stepClick(type, formChild);
        extraFunc();
        break;

      case 'cancel':
        // if (stepClick) stepClick(type, formChild);
        extraFunc();
        break;

      default:
        // extraFunc()
        break;
    }
  };

  var renderFooter = function renderFooter() {
    if (type === 'stepForm') {
      return formItemGroup.map(function (item, index) {
        if (stepsConfig && stepsConfig.current !== index) return null;
        return /*#__PURE__*/React.createElement(ActionList, {
          key: index,
          list: item.actions || [],
          onStep: handleStepType,
          form: formChild,
          other: props
        });
      });
    }

    if (type === 'tabForm') {
      return formItemGroup.map(function (item, index) {
        if (tabsConfig && tabsConfig.activeKey !== item.key) return null;
        return /*#__PURE__*/React.createElement(ActionList, {
          key: index,
          list: item.actions || [],
          form: formChild,
          other: props
        });
      });
    }

    return fieldStatus === 'viewOnly' || fieldStatus === 'disabled' || hideFooter ? false : renderButtonGroup() || footer;
  };

  return /*#__PURE__*/React.createElement(_Modal, _extends({
    destroyOnClose: true,
    maskClosable: false
  }, otherProps, {
    visible: visible,
    title: title,
    width: general.modalSize[size].width,
    footer: renderFooter(),
    className: "standardModal ".concat(className || '', " ").concat(fieldStatus === 'viewOnly' ? 'is-view' : ''),
    style: _objectSpread({
      top: '80px'
    }, style),
    bodyStyle: _objectSpread({
      maxHeight: bodyMaxHeight,
      overflowY: 'scroll'
    }, bodyStyle),
    onCancel: handleCancel,
    afterClose: onAfterClose,
    onOk: handleSubmit
  }), children, type === 'form' && /*#__PURE__*/React.createElement(_Form, {
    layout: formLayout,
    ref: setModalFormRef,
    form: modalForm,
    onFinish: handleSubmit,
    hideRequiredMark: fieldStatus === 'viewOnly' || hideRequiredMark // initialValues={{ ...initialValues }}
    ,
    scrollToFirstError: true,
    className: "modalForm"
  }, formPrefix && /*#__PURE__*/React.createElement(_Row, {
    type: "flex"
  }, formPrefix(modalForm, props, forceUpdateForm)), formItemGroup ? renderFormItemGroup() : null, formPostfix && /*#__PURE__*/React.createElement(_Row, {
    type: "flex"
  }, formPostfix(modalForm, props, forceUpdateForm), " ")), type === 'tabForm' && /*#__PURE__*/React.createElement(TabForm, {
    grid: size,
    layout: formLayout,
    fieldStatus: fieldStatus,
    actionHide: true,
    getFormFields: function getFormFields(fields, form) {
      setFormChild(form);
      _getFormFields && _getFormFields(fields, form);
    },
    formItemGroup: formItemGroup,
    tabsConfig: tabsConfig,
    onSubmit: handleSubmit,
    initialValues: _objectSpread({}, initialValues)
  }), type === 'stepForm' && /*#__PURE__*/React.createElement(StepForm, {
    grid: size,
    layout: formLayout,
    fieldStatus: fieldStatus,
    actionHide: true,
    getFormFields: function getFormFields(fields, form) {
      setFormChild(form);
      _getFormFields && _getFormFields(fields, form);
    },
    formItemGroup: formItemGroup,
    stepsConfig: stepsConfig,
    initialValues: _objectSpread({}, initialValues),
    onSubmit: handleSubmit
  }));
};

export default StandardModalFunc;