import "antd/es/popover/style";
import _Popover from "antd/es/popover";
import "antd/es/radio/style";
import _Radio from "antd/es/radio";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import classNames from 'classnames';
import './index.less'; //
// export interface StandardPanelProps {
//     children?: React.ReactNode;
//     style?: React.CSSProperties;
//     className?: string;
//     height?: Boolean;
//     title?: any;
//     badges?: badgesList[];
//     cateConfig?: GroupList[];
//     buttonConfig?: GroupList[];
//     type?: string;
//     postfix?: React.ReactNode;
// }
// export interface GroupList {
//     activeKey?: string;
//     list?: string[] | any;
//     onChange?: () => void;
//     className?: string;
// }
//
// export interface badgesList {
//     value?: string;
//     label?: string[] | any;
//     color?: string;
// }

var StandardPanel = function StandardPanel(props) {
  var className = props.className,
      style = props.style,
      height = props.height,
      children = props.children,
      title = props.title,
      badges = props.badges,
      cateConfig = props.cateConfig,
      buttonConfig = props.buttonConfig,
      type = props.type,
      postfix = props.postfix;

  var RenderGroupList = function RenderGroupList(values) {
    var list = values.list,
        activeKey = values.activeKey,
        onChange = values.onChange,
        className = values.className;

    var handleChange = function handleChange(e) {
      if (onChange) {
        onChange(e.target.value, list.filter(function (data) {
          return data.value === e.target.value;
        })[0]);
      }
    };

    return /*#__PURE__*/React.createElement("div", {
      className: className
    }, /*#__PURE__*/React.createElement(_Radio.Group, {
      defaultValue: activeKey,
      buttonStyle: "solid",
      onChange: handleChange
    }, list && Array.isArray(list) && list.map(function (item) {
      return /*#__PURE__*/React.createElement(_Radio.Button, {
        key: item.value,
        value: item.value
      }, item.label);
    })));
  }; // 是否显示提示框


  var popoverShow = function popoverShow() {
    return title.content ? /*#__PURE__*/React.createElement(_Popover, {
      content: title.content,
      placement: title.placement
    }, " ", title.label, " ") : title;
  };

  return /*#__PURE__*/React.createElement("div", {
    className: classNames('spec-panel', className, type === 'reverse' ? 'spec-panel-reverse' : '', type === 'border' ? 'spec-panel-border' : ''),
    style: _objectSpread(_objectSpread({}, style), {}, {
      height: "".concat(height, "px")
    })
  }, /*#__PURE__*/React.createElement("div", {
    className: "spec-panel-header"
  }, /*#__PURE__*/React.createElement("div", {
    className: "spec-panel-title"
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames(type === 'border' ? 'sub-header-line' : 'sub-header-base')
  }, /*#__PURE__*/React.createElement("span", {
    className: "header-text"
  }, popoverShow()))), /*#__PURE__*/React.createElement("div", {
    className: "spec-panel-inner"
  }, badges && Array.isArray(badges) && /*#__PURE__*/React.createElement("span", {
    className: "badges"
  }, badges.map(function (item) {
    return /*#__PURE__*/React.createElement("span", {
      className: "badges-item",
      key: item.value
    }, /*#__PURE__*/React.createElement("i", {
      style: item.color ? {
        background: item.color
      } : {}
    }), item.label);
  }))), cateConfig && /*#__PURE__*/React.createElement(RenderGroupList, _extends({
    className: "spec-panel-cate"
  }, cateConfig)), buttonConfig && /*#__PURE__*/React.createElement(RenderGroupList, _extends({
    className: "spec-panel-buttons"
  }, buttonConfig)), postfix && /*#__PURE__*/React.createElement("div", {
    className: "spec-panel-extra"
  }, postfix)), /*#__PURE__*/React.createElement("div", {
    className: "spec-panel-body"
  }, children));
};

export default StandardPanel;