import React, { useEffect, useState } from 'react';
import classNames from 'classnames';
import './index.less';

var DragBar = function DragBar(props) {
  var direction = props.direction,
      className = props.className,
      onMouseDown = props.onMouseDown;
  var directionStyle = direction === 'left' ? "spec-grid-dragbar-left-horizontal" : direction === 'right' ? "spec-grid-dragbar-right-horizontal" : direction === 'top' ? "spec-grid-dragbar-up-vertical" : "spec-grid-dragbar-down-vertical";

  var handleMouseDown = function handleMouseDown(e) {
    onMouseDown(e, direction);
  };

  return /*#__PURE__*/React.createElement("div", {
    className: classNames(directionStyle, className),
    onMouseDown: handleMouseDown
  });
};

export default DragBar;