"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/tooltip/style");

var _tooltip = _interopRequireDefault(require("antd/es/tooltip"));

require("antd/es/col/style");

var _col = _interopRequireDefault(require("antd/es/col"));

require("antd/es/form/style");

var _form = _interopRequireDefault(require("antd/es/form"));

var _react = _interopRequireWildcard(require("react"));

var _index = require("../../data/index");

var _index2 = _interopRequireDefault(require("../FieldComponent/index"));

var _index3 = _interopRequireDefault(require("../../SpecIconFont/index"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var FormItem = _form.default.Item;

var RenderItemGroup = function RenderItemGroup(props) {
  var itemGroup = props.itemGroup,
      _props$size = props.size,
      size = _props$size === void 0 ? 'md' : _props$size,
      _props$fieldStatus = props.fieldStatus,
      fieldStatus = _props$fieldStatus === void 0 ? 'default' : _props$fieldStatus,
      displayLayout = props.displayLayout,
      getFormFields = props.getFormFields,
      form = props.form;

  var setColSpan = function setColSpan(display, modalSize) {
    if (_typeof(display) === 'object' || display === 'block' || modalSize === 'xs') {
      return 24;
    }

    if (modalSize === 'lg') {
      return 8;
    }

    return 12;
  };

  var updateFormFields = function updateFormFields(newVal) {
    if (newVal) form && form.setFieldsValue(_objectSpread({}, newVal));
    if (getFormFields) getFormFields(form && form.getFieldsValue() || {}, form);
  };

  (0, _react.useEffect)(function () {
    updateFormFields();
  }, [form]); // 渲染隐藏指定控件

  var itemIsHide = function itemIsHide(isHide) {
    if (!isHide) return false;

    if (typeof isHide === 'function') {
      return isHide(form ? form.getFieldsValue() : {}, form, fieldStatus);
    }

    return isHide;
  }; // 渲染表单控件


  var renderFormField = function renderFormField(field) {
    var componentStyle = field.componentStyle,
        extra = field.extra,
        preExtra = field.preExtra; // 当前可传参的配置值

    if (preExtra || extra) {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, preExtra ? preExtra() : '', /*#__PURE__*/_react.default.createElement(FormItem, {
        noStyle: true,
        name: field.filedName
      }, /*#__PURE__*/_react.default.createElement(_index2.default, _extends({}, field, {
        onChange: function onChange(val) {
          var updateValue = val;

          if (field.type === 'input' || field.type === 'textarea' || field.type === 'radio' || field.type === 'password') {
            updateValue = val.target.value;
          }

          updateFormFields(_defineProperty({}, field.filedName, updateValue));
          if (field.onChange) field.onChange(val, form);
        },
        fieldStatus: fieldStatus,
        style: componentStyle || _objectSpread({}, _index.general.formItemStyle.wide)
      }))), extra ? extra() : '');
    } else {
      return /*#__PURE__*/_react.default.createElement(_index2.default, _extends({}, field, {
        onChange: function onChange(val) {
          var updateValue = val;

          if (field.type === 'input' || field.type === 'textarea' || field.type === 'radio' || field.type === 'password') {
            updateValue = val.target.value;
          }

          updateFormFields(_defineProperty({}, field.filedName, updateValue));
          if (field.onChange) field.onChange(val, form);
        },
        fieldStatus: fieldStatus,
        style: componentStyle || _objectSpread({}, _index.general.formItemStyle.wide)
      }));
    }
  };

  if (itemGroup && Array.isArray(itemGroup)) {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, itemGroup.map(function (item, index) {
      var label = item.label,
          description = item.description,
          isHide = item.isHide,
          type = item.type,
          customRender = item.customRender,
          filedName = item.filedName,
          _item$display = item.display,
          display = _item$display === void 0 ? 'side' : _item$display; // 当前可传参的配置值

      if (itemIsHide(isHide, item)) return null;
      var formLayout = {};

      if (typeof display === 'string') {
        formLayout = display === 'block' ? _index.general.modalSize[size].formBlockLayout : _index.general.modalSize[size].formLayout;
      } else {
        formLayout = item.display; // 对象类型传值如： {labelCol: {span: 3},wrapperCol: {span: 8}}
      }

      if (displayLayout) {
        // 如果未配置，则使用以下配置值
        formLayout = _objectSpread({}, displayLayout);
      }

      if (type === 'title' || type === 'html') {
        return /*#__PURE__*/_react.default.createElement(_col.default, {
          key: index,
          span: item.colSpan || 24
        }, type === 'title' ? /*#__PURE__*/_react.default.createElement("h3", {
          className: "modalPanelTitle"
        }, label) : label);
      }

      return /*#__PURE__*/_react.default.createElement(_col.default, {
        key: index,
        span: item.colSpan || setColSpan(item.display, size)
      }, /*#__PURE__*/_react.default.createElement(FormItem, _extends({
        name: type !== 'custom' && filedName,
        className: fieldStatus === 'viewOnly' ? 'form-item-view-only' : '',
        label: description ? /*#__PURE__*/_react.default.createElement("span", null, label, /*#__PURE__*/_react.default.createElement(_tooltip.default, {
          title: description
        }, /*#__PURE__*/_react.default.createElement(_index3.default, {
          name: "info"
        }))) : label,
        rules: item.rules || (item.fieldOptions ? item.fieldOptions.rules : [])
      }, formLayout, item.protoFormItem), type === 'custom' && customRender ? customRender(form, _objectSpread({}, item), fieldStatus) : renderFormField(_objectSpread({}, item))));
    }));
  }

  return itemGroup;
  /* 如果是ReactNode则直接返回 */
};

var _default = RenderItemGroup;
exports.default = _default;