"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/tree/style");

var _tree = _interopRequireDefault(require("antd/es/tree"));

require("antd/es/empty/style");

var _empty = _interopRequireDefault(require("antd/es/empty"));

require("antd/es/popconfirm/style");

var _popconfirm = _interopRequireDefault(require("antd/es/popconfirm"));

var _react = _interopRequireWildcard(require("react"));

var _index = _interopRequireDefault(require("../SpecIconFont/index"));

require("./index.less");

var _util = require("./util");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RefactorTree = function RefactorTree(props) {
  var treeData = props.treeData,
      rootName = props.rootName,
      rootKey = props.rootKey,
      rootIcon = props.rootIcon,
      emptyDescription = props.emptyDescription,
      _props$optionName = props.optionName,
      optionName = _props$optionName === void 0 ? {
    value: 'value',
    title: 'title',
    children: 'children',
    disabled: 'disabled'
  } : _props$optionName,
      defaultSelectedKeys = props.defaultSelectedKeys,
      nodeExtra = props.nodeExtra,
      _props$selectable = props.selectable,
      selectable = _props$selectable === void 0 ? true : _props$selectable,
      nodeControl = props.nodeControl,
      limitKey = props.limitKey,
      checkedKeys = props.checkedKeys,
      checkStrictly = props.checkStrictly,
      titleRender = props.titleRender,
      otherProps = _objectWithoutProperties(props, ["treeData", "rootName", "rootKey", "rootIcon", "emptyDescription", "optionName", "defaultSelectedKeys", "nodeExtra", "selectable", "nodeControl", "limitKey", "checkedKeys", "checkStrictly", "titleRender"]); // const { title, value, children, disabled } = { value: 'value', title: 'title', children: 'children', disabled: 'disabled', ...optionName }
  // 重新组合指定数据源字段


  var transTreeData = (0, _react.useMemo)(function () {
    var _ref;

    var afterTransData = (0, _util.transDataParam)(treeData, optionName); // 通过转换后的数据

    var resultData; // 如果有配置根节点,则添加 一个根节点数据

    resultData = rootName ? [(_ref = {}, _defineProperty(_ref, optionName.title || 'title', rootName), _defineProperty(_ref, optionName.key || 'key', rootKey || '0'), _defineProperty(_ref, 'children', afterTransData), _ref)] : afterTransData; // 有配置limitKey指定限制同级节点时，添加判断节点选择限制(在父子节点不相关联条件下使用checkStrictly=true)

    if (checkStrictly && limitKey && checkedKeys) {
      if (Array.isArray(checkedKeys) && checkedKeys.length > 0 || checkedKeys && Array.isArray(checkedKeys.checked) && checkedKeys.checked.length > 0) {
        resultData = (0, _util.resetDataWithLimit)(Array.isArray(checkedKeys) ? checkedKeys : checkedKeys.checked, resultData, optionName, limitKey);
      }
    }

    return resultData;
  }, [treeData, optionName, checkStrictly, limitKey, checkedKeys]); // const [dataList, setDataList] = useState([])
  // 限制节点选中条件下更新列表数据

  var resetDataWithLimitEX = function resetDataWithLimitEX(hasKeys, list, resultList) {
    // 利用ID匹配对应选中的完整节点数据
    var filterCheckedNode = function filterCheckedNode(ids, preList, matchList) {
      if (Array.isArray(preList) && preList.length > 0) {
        preList.forEach(function (item, i) {
          if (ids.includes(item[value])) {
            matchList.push(_objectSpread({}, item));
          }

          filterCheckedNode(ids, item[children], matchList);
        });
      }
    }; // 筛选同一层级可选择，其他层级数据不可选择（限制按指定字段名的层级数据）


    var filterResetSameLevel = function filterResetSameLevel(preList, resData, matchData) {
      if (Array.isArray(preList) && preList.length > 0) {
        preList.forEach(function (item, i) {
          resData[i] = _objectSpread({}, item);
          resData[i].isLimit = item[limitKey] !== matchData; // [limitKey];

          var newDeepArr = [];
          filterResetSameLevel(item[children], newDeepArr, matchData);
          resData[i][children] = newDeepArr;
        });
      }
    };

    var matchItems = [];
    filterCheckedNode(hasKeys, list, matchItems); // 先筛选出来选中节点的数据，取其中的 level 层级的值(数据必须保证同级类型值一致)

    if (matchItems.length > 0) {
      filterResetSameLevel(list, resultList, matchItems[0][limitKey]);
    }
  };
  /*  useEffect(() => {
      // 有配置limitKey指定限制同级节点时，添加判断节点选择限制(在父子节点不相关联条件下使用checkStrictly=true)
      if (checkStrictly && limitKey && checkedKeys) {
        if (Array.isArray(checkedKeys) && checkedKeys.length > 0 || Array.isArray(checkedKeys.checked) && checkedKeys.checked.length > 0) {
          const resetList = []
          resetDataWithLimitEX(checkedKeys.checked || checkedKeys, treeData, resetList)
          setDataList(resetList)
        } else {
          setDataList(treeData || [])
        }
      } else {
        setDataList(treeData || []) // 默认状态直接赋值传进来的数据
      }
    }, [treeData, checkedKeys])*/


  var handleToSelectTreeNode = function handleToSelectTreeNode(key, e) {
    var onSelect = props.onSelect;

    var currentData = _objectSpread({}, e.node); // delete currentData.dragOver
    // delete currentData.dragOverGapBottom
    // delete currentData.dragOverGapTop
    // delete currentData.expanded
    // delete currentData.halfChecked


    var multiSelectedData = [];
    e.selectedNodes.map(function (item) {
      return multiSelectedData.push(item);
    }); // 多选条件下,当前选中所有节点数据

    onSelect && onSelect(key, {
      currentData: currentData,
      multiData: multiSelectedData
    }, e);
  };

  var handleToCheckTreeNode = function handleToCheckTreeNode(keys, e) {
    var onCheck = props.onCheck;

    var currentData = _objectSpread({}, e.node);

    var multiCheckedData = [];
    e.checkedNodes.map(function (item) {
      return multiCheckedData.push(item);
    }); // 多选条件下,当前选中所有节点数据

    onCheck && onCheck(keys, {
      currentData: currentData,
      multiData: multiCheckedData
    }, e);
  };

  var handleNodeControl = function handleNodeControl(e, type, nodeData) {
    e.stopPropagation();
    var onEdit = nodeControl.onEdit,
        onDelete = nodeControl.onDelete;

    if (type === 'edit') {
      onEdit && onEdit(nodeData);
    }

    if (type === 'delete') {
      onDelete && onDelete(nodeData);
    }
  }; // const <Icon type={selected ? 'frown' : 'frown-o'} />


  var renderNodeTitle = function renderNodeTitle(item) {
    if (titleRender) return titleRender(item);
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, item[optionName.title || 'title'], nodeControl ? /*#__PURE__*/_react.default.createElement("span", {
      className: "treeControl"
    }, /*#__PURE__*/_react.default.createElement("a", {
      onClick: function onClick(e) {
        handleNodeControl(e, 'edit', item);
      }
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      name: 'edit'
    })), /*#__PURE__*/_react.default.createElement(_popconfirm.default, {
      placement: 'top',
      title: "\u786E\u5B9A\u8981\u5220\u9664\uFF1A".concat(item[optionName.title || 'title'], "\u5417\uFF1F"),
      icon: /*#__PURE__*/_react.default.createElement(_index.default, {
        name: "question"
      }),
      onConfirm: function onConfirm(e) {
        handleNodeControl(e, 'delete', item);
      }
    }, /*#__PURE__*/_react.default.createElement("a", {
      onClick: function onClick(e) {
        return e.stopPropagation();
      }
    }, /*#__PURE__*/_react.default.createElement(_index.default, {
      name: 'delete'
    })))) : null, nodeExtra && nodeExtra(item));
  };

  if (transTreeData.length == 0) {
    return /*#__PURE__*/_react.default.createElement(_empty.default, {
      image: _empty.default.PRESENTED_IMAGE_SIMPLE,
      description: emptyDescription
    });
  } else {
    var defExpand = [];

    if (defaultSelectedKeys && defaultSelectedKeys.length > 0) {
      defExpand = defaultSelectedKeys;
    } else {
      defExpand = rootKey ? [rootKey] : ['0'];
    }

    return /*#__PURE__*/_react.default.createElement(_tree.default, _extends({}, otherProps, {
      onSelect: function onSelect(keys, e) {
        return handleToSelectTreeNode(keys, e);
      },
      onCheck: function onCheck(keys, e) {
        return handleToCheckTreeNode(keys, e);
      },
      defaultExpandedKeys: defExpand,
      defaultSelectedKeys: defaultSelectedKeys,
      selectable: selectable,
      checkedKeys: checkedKeys,
      checkStrictly: checkStrictly,
      treeData: transTreeData,
      titleRender: renderNodeTitle
    }));
  }
};

var _default = RefactorTree;
exports.default = _default;