"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/card/style");

var _card = _interopRequireDefault(require("antd/es/card"));

require("antd/es/table/style");

var _table = _interopRequireDefault(require("antd/es/table"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _index = _interopRequireDefault(require("../components/ButtonGroup/index"));

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var StandardTable = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var handleTableChange = function handleTableChange(pagination, filters, sorter) {
    var onChange = props.onChange;

    if (onChange) {
      onChange(pagination, filters, sorter);
    }
  };

  var _props$data = props.data,
      data = _props$data === void 0 ? {} : _props$data,
      rowKey = props.rowKey,
      rowSelection = props.rowSelection,
      columns = props.columns,
      hideOrderNumber = props.hideOrderNumber,
      _props$orderNumber = props.orderNumber,
      orderNumber = _props$orderNumber === void 0 ? {} : _props$orderNumber,
      className = props.className,
      emptyText = props.emptyText,
      codes = props.codes,
      permissionCodes = props.permissionCodes,
      rest = _objectWithoutProperties(props, ["data", "rowKey", "rowSelection", "columns", "hideOrderNumber", "orderNumber", "className", "emptyText", "codes", "permissionCodes"]);

  var resetColumns = [_objectSpread({
    width: 58,
    align: 'center',
    title: '序号',
    key: 'orderNum',
    // fixed: 'left',
    // render: (text, o, index) => pagination ?  (pagination.current - 1) * pagination.pageSize + index + 1 : index + 1,
    render: function render(text, record, index) {
      return index + 1;
    }
  }, orderNumber)];
  var _data$list = data.list,
      list = _data$list === void 0 ? [] : _data$list,
      pagination = data.pagination;

  var paginationProps = _objectSpread({
    // showQuickJumper: true,
    className: 'spec-pagination',
    showSizeChanger: true,
    pageSizeOptions: ['5', '10', '15', '20', '30', '50'],
    showTotal: function showTotal(total, range) {
      return "".concat(range[0], "-").concat(range[1], "\u6761 \u5171").concat(total, "\u6761");
    }
  }, pagination);

  if (columns) {
    columns.map(function (colItem) {
      if (colItem.type === 'action') {
        colItem.width = colItem.width || (colItem.buttonGroup.length > 1 ? 120 : 80);
        colItem.align = 'center';
        colItem.title = colItem.title || '操作';
        colItem.key = 'control'; // colItem.fixed = colItem.fixed || 'right'

        colItem.render = function (text, record, rowIndex) {
          // 按钮列表组
          var renderTableButtonGroup = function renderTableButtonGroup(buttonGroup) {
            if (!buttonGroup) return '-';
            var recombinationGroup = []; // 重组数据
            // 类型为数组

            if (Array.isArray(buttonGroup)) recombinationGroup = buttonGroup; // 类型为方法

            if (typeof buttonGroup === 'function') recombinationGroup = buttonGroup(text, record, rowIndex); // 方法返回数组结构
            // 判断是否是数组且长度大于0时 ？{如下结构渲染} ： {按buttonGroup返回的node渲染}

            if (Array.isArray(buttonGroup) || typeof buttonGroup === 'function') {
              if (recombinationGroup.length === 0) return '-';
              return /*#__PURE__*/_react.default.createElement(_index.default, {
                type: "text",
                min: colItem.min || 2 // 配置按钮展示最少数量，其他的将会被折叠
                ,
                options: recombinationGroup,
                codes: codes,
                permissionCodes: permissionCodes,
                rowParams: {
                  text: text,
                  record: record,
                  rowIndex: rowIndex
                }
              });
            }
          };

          return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, renderTableButtonGroup(colItem.buttonGroup));
        };
      } else if (!colItem.render) {
        // 若未配置render，则给加个默认的返回方法
        colItem.render = function (text, record, rowIndex) {
          return text || text === 0 ? text : '-';
        };

        return colItem;
      }

      return colItem;
    });
    resetColumns = hideOrderNumber ? columns : resetColumns.concat(columns);
  }

  return /*#__PURE__*/_react.default.createElement(_card.default, {
    className: (0, _classnames.default)('standard-table', className),
    bordered: false,
    ref: ref
  }, /*#__PURE__*/_react.default.createElement(_table.default, _extends({
    rowKey: rowKey || 'id',
    rowSelection: rowSelection ? _objectSpread(_objectSpread({}, rowSelection), {}, {
      columnWidth: 30
    }) : rowSelection,
    dataSource: list,
    pagination: !pagination ? false : paginationProps,
    onChange: handleTableChange,
    columns: resetColumns,
    locale: {
      filterConfirm: '确定',
      filterReset: '重置',
      emptyText: emptyText || '暂无数据'
    }
  }, rest)));
});

var _default = StandardTable;
exports.default = _default;