"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _DragBar = _interopRequireDefault(require("./DragBar"));

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var DragContent = function DragContent(props) {
  var children = props.children,
      className = props.className,
      direction = props.direction,
      _props$moveMaxWidth = props.moveMaxWidth,
      moveMaxWidth = _props$moveMaxWidth === void 0 ? 0 : _props$moveMaxWidth,
      _props$moveMaxHeight = props.moveMaxHeight,
      moveMaxHeight = _props$moveMaxHeight === void 0 ? 0 : _props$moveMaxHeight,
      style = props.style,
      dragMouseDown = props.dragMouseDown,
      dragMouseMove = props.dragMouseMove,
      dragMouseUp = props.dragMouseUp;
  var divRef = (0, _react.useRef)();

  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      targetWidth = _useState2[0],
      setTargetWidth = _useState2[1];

  var _useState3 = (0, _react.useState)(),
      _useState4 = _slicedToArray(_useState3, 2),
      targetHeight = _useState4[0],
      setTargetHeight = _useState4[1];

  (0, _react.useEffect)(function () {
    setTargetWidth(divRef.current.offsetWidth);
    setTargetHeight(divRef.current.offsetHeight);
  }, []);

  var onmousedown = function onmousedown(e, direction) {
    var parent = divRef.current;
    var nextNode = parent.nextSibling; //相邻兄弟节点

    var prevNode = parent.previousSibling; //相邻兄弟节点
    //获取前后兄弟节点宽高 

    var prevWidth = 0,
        prevHeight = 0,
        nextWidth = 0,
        nextHeight = 0;

    if (prevNode) {
      prevWidth = prevNode.offsetWidth;
      prevHeight = prevNode.offsetHeight;
    }

    if (nextNode) {
      nextWidth = nextNode.offsetWidth;
      nextHeight = nextNode.offsetHeight;
    } //鼠标按下


    if (dragMouseDown) dragMouseDown(e, direction);
    var initWidth = parent.offsetWidth;
    var initHeight = parent.offsetHeight;
    var initLeft = parent.offsetLeft;
    var initTop = parent.offsetTop;
    var startX = e.clientX;
    var startY = e.clientY;

    document.onmousemove = function (e) {
      var currX = e.clientX;
      var currY = e.clientY;
      var disY = currY - startY;
      var disX = currX - startX;
      var hasT = /top/.test(direction);
      var hasB = /bottom/.test(direction);
      var hasL = /left/.test(direction);
      var hasR = /right/.test(direction);

      if (hasL || hasR) {
        var newWidth = initWidth + (hasL ? -disX : hasR ? disX : 0);
        var width = newWidth > 0 ? newWidth : 0; //获取兄弟节点可变动的宽度

        var changeWidth = hasL ? prevWidth : hasR ? nextWidth : 0;
        var maxWidth = changeWidth + initWidth;

        if (moveMaxWidth > 0 && maxWidth > moveMaxWidth) {
          maxWidth = moveMaxWidth;
        } //拉伸容器宽度不可小于初始宽度
        //判断拉伸宽度不可超过 拉伸容器宽度+变动的兄弟容器宽度或设置的最大宽度


        if (width > targetWidth && width <= maxWidth) {
          //左拉且有前兄弟节点即变化其宽度
          if (hasL && prevNode) {
            var newPrevWidth = prevWidth + (hasL ? disX : hasR ? -disX : 0);
            prevNode.style.width = newPrevWidth + 'px';
          } //右拉且有后兄弟节点即变化其宽度


          if (hasR && nextNode) {
            var newNextWidth = nextWidth + (hasL ? disX : hasR ? -disX : 0);
            nextNode.style.width = newNextWidth + 'px';
          } //设置拉伸容器的宽度


          parent.style.width = width + "px";
        }
      }

      if (hasT || hasB) {
        var newHeight = initHeight + (hasT ? -disY : hasB ? disY : 0);
        var height = newHeight > 0 ? newHeight : 0; //获取兄弟节点需要变动的高度

        var changeHeight = hasT ? prevHeight : hasB ? nextHeight : 0;
        var maxHeight = changeHeight + initHeight;

        if (moveMaxHeight > 0 && maxHeight > moveMaxHeight) {
          maxHeight = moveMaxHeight;
        } //拉伸容器高度不可小于初始高度 
        //判断拉伸高度不可超过 拉伸容器高度+变动的兄弟容器高度或设置的最大高度


        if (height > targetHeight && height <= maxHeight) {
          //上拉且有前兄弟节点即变化其高度
          if (hasT && prevNode) {
            var newPrevHeight = prevHeight + (hasT ? disY : hasB ? -disY : 0);
            prevNode.style.height = newPrevHeight + 'px';
          } //下拉且有后兄弟节点即变化其高度


          if (hasB && nextNode) {
            var newNextHeight = nextHeight + (hasT ? disY : hasB ? -disY : 0);
            nextNode.style.height = newNextHeight + 'px';
          } //设置拉伸容器的高度


          parent.style.height = height + "px";
        }
      } //鼠标按下


      if (dragMouseMove) dragMouseMove(e, direction);
    };

    document.onmouseup = function (e) {
      document.onmousemove = document.onmouseup = null; //鼠标按下

      if (dragMouseUp) dragMouseUp(e, direction);
    };
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    ref: divRef,
    className: (0, _classnames.default)("spec-grid-dragContent", className),
    style: style
  }, children, direction && direction.map(function (item, idx) {
    return /*#__PURE__*/_react.default.createElement(_DragBar.default, {
      key: idx,
      direction: item,
      onMouseDown: onmousedown
    });
  }));
};

var _default = DragContent;
exports.default = _default;