"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.btnClickFunc = exports.btnIsDisabled = exports.btnIsHide = exports.removeNoPermission = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

// 按钮方法
var btnClickFunc = function btnClickFunc(fn) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  if (!fn) return null;
  var paramsArr = [];

  if (_typeof(params) === 'object') {
    Object.keys(params).map(function (item) {
      paramsArr.push(params[item]);
    });
  }

  if (typeof fn === 'function') {
    return fn.apply(void 0, paramsArr); // 表格列返回的是方法
  }

  return fn;
}; // 按钮是否禁用


exports.btnClickFunc = btnClickFunc;

var btnIsDisabled = function btnIsDisabled(isDisabled) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  if (!isDisabled) return false;
  var paramsArr = [];

  if (_typeof(params) === 'object') {
    Object.keys(params).map(function (item) {
      paramsArr.push(params[item]);
    });
  }

  if (typeof isDisabled === 'function') {
    return isDisabled.apply(void 0, paramsArr); // 表格列返回的是方法
  }

  return isDisabled;
}; // 按钮是否隐藏


exports.btnIsDisabled = btnIsDisabled;

var btnIsHide = function btnIsHide(isHide) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  if (!isHide) return false;
  var paramsArr = [];

  if (_typeof(params) === 'object') {
    Object.keys(params).map(function (item) {
      paramsArr.push(params[item]);
    });
  }

  if (typeof isHide === 'function') {
    return isHide.apply(void 0, paramsArr); // 表格列返回的是方法
  }

  return isHide;
}; // 重新组合数据(排除不包含在permissionCodes内及isHide数据


exports.btnIsHide = btnIsHide;

var removeNoPermission = function removeNoPermission(array, permissionCodes, codes, params) {
  return Array.isArray(array) && array.filter(function (item) {
    if (item.children) {
      item.children = removeNoPermission(item.children, permissionCodes, codes, params);
      if (item.children.length === 0) return false; // 如果子集合过滤为空时，不返当前数据
    } // permissionCodes未定义，则直接返回不进行过滤


    if (item.hasOwnProperty('code') && permissionCodes) {
      // if (!permissionCodes) return true //  permissionCodes未定义，则直接返回不进行过滤
      // 判断是否包含 'code'字段，如果包含则先过滤有在 permissionCodes内的(permissionCodes数组为0时，也不返回数据)
      // 并用是不隐藏的条件
      return permissionCodes.length !== 0 && permissionCodes.includes(item.code) && !btnIsHide(item.isHide, params);
    }

    if (item.hasOwnProperty('isHide')) {
      // 判断是否包含 'isHide'字段，如果包含则先过滤 isHide 为false
      return !btnIsHide(item.isHide, params);
    }

    return true;
  }).map(function (resultItem) {
    // 与codes进行对比，相应的 code匹配以对应的name,icon,code返回
    // 如果有配置code，则使用func.code.js里面配置的名称
    if (codes && resultItem.code) {
      var matchIndex = _lodash.default.findIndex(codes, function (btnItem) {
        return btnItem.code === resultItem.code;
      });

      if (matchIndex !== -1) {
        // 如果有配置code，则使用func.code.js里面配置的名称
        resultItem = _objectSpread(_objectSpread({}, resultItem), codes[matchIndex]);
      }
    }

    return resultItem;
  });
};

exports.removeNoPermission = removeNoPermission;